(** Proofs - blocks of copy **)
Require Arith.
Require cap.
Require cdsa.
Require property.
Require free.
Require property2.
Require malloc.
Require copydefs.
Require copyprop.

Lemma WF_copy : (l0:(list int))
 (Infer (CT_Copy l0) (T_copy l0) C_copy).
Proof.
Unfold C_copy.
(* movi tgt nil *)
Intro; Apply I_movi with [s:state] (T_copy l0 s)/\(getValinR s tgt)=pnil.
Unfold T_copy; Unfold updateR; Unfold getValinR.
Unfold lookupR; Fold lookupR; Unfold beq_reg.
Intros; Constructor; Auto.
Inversion_clear H0.
Inversion_clear H1.
Exists x; Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply Slist_RF_Insensitive.
Intro; Apply Good_RF_Insensitive.
(* movi cprev nil *)
Apply I_movi with [s:state](T_copy l0 s)/\(getValinR s r26)=(0)
  /\(getValinR s cprev)=pnil.
Unfold T_copy; Unfold updateR; Unfold getValinR.
Intros; Unfold lookupR; Fold lookupR; Unfold beq_reg.
Inversion_clear H0.
Inversion_clear H1.
Inversion_clear H0.
Constructor; Auto.
Exists x; Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply Slist_RF_Insensitive.
Intro; Apply Good_RF_Insensitive.
(* jd test *)
Apply I_jd with (T_test l0).
CTLookupTac.
Unfold T_copy; Unfold T_test; Induction s; Unfold getValinR; Intros.
SplitAllHyps.
Inversion_clear H0.
SplitAllHyps.
Induction s; Apply star_subst_sameR
  with (Slist x (lookupR b r25) (0)) (Good (lookupR b r2)); Auto.
Clear H0; Intros.
Constructor; Intros.
Constructor; Auto.
Exists x; Constructor; Auto.
Absurd (lookupR b r28)=O; Auto.
Save.

Lemma WF_test : (l0:(list int))
 (Infer (CT_Copy l0) (T_test l0) C_test).
Proof.
Unfold C_test; Intro.
(* bgti src nil next0 *)
Apply I_bgti with (T_halt l0) (T_next0 l0).
CTLookupTac.
Unfold T_test; Unfold T_halt; Intros.
Cut (star [s:state](EX l | (Slist l (getValinR (H,R) r26) (0) s) /\ l=l0)
        (Good (getValinR (H,R) r2)) (H,R)).
Clear H1; Intros.
Inversion_clear H1.
Inversion_clear H2.
SplitAllHyps.
Inversion_clear H3.
Inversion_clear H4.
Exists x1; Constructor; Auto.
Exists x; Exists x0; Constructor; Auto.
Apply star_subst_sameR with 
[s:(heap*rfile)]
((getValinR s r28)=(0)
 ->(EX l:(list nat) | (Slist l (getValinR s r25) (0) s)/\l=l0)
 /\(getValinR s r26)=(0))
 /\(~(getValinR s r28)=(0)
 ->(EX la:(list nat) |
    (EX lb:(list nat) |
      (EX b:nat |
        (star
          (star (Slist la (getValinR s r25) (0))
            (Slist lb (getValinR s r26)
              (getValinR s r28)))
          (Pair (getValinR s r28) b (getValinR s r25))
           s)/\(app lb (cons b la))=l0))))
         (Good (getValinR (H,R) r2)); Auto.
Unfold getValinR; Clear H1; Intros.
Inversion_clear H2.
Compare (lookupR R r28) O; Intro.
Cut (EX l:(list nat) | (Slist l (lookupR R r25) (0) (H1,R))/\l=l0)
         /\(lookupR R r26)=(0); Auto.
Clear H3; Clear H4; Intros.
Inversion_clear H2.
Replace (lookupR R r26) with (lookupR R r25); Auto.
Rewrite H4; Auto with arith.
Cut (EX la:(list nat) |
            (EX lb:(list nat) |
               (EX b:nat |
                  (star
                    (star (Slist la (lookupR R r25) (0))
                      (Slist lb (lookupR R r26) (lookupR R r28)))
                    (Pair (lookupR R r28) b (lookupR R r25)) (H1,R))
                  /\(app lb (cons b la))=l0))); Auto.
Clear H3; Clear H4; Intros.
SplitAllExs.
Inversion_clear H3.
Exists (app x0 (cons x1 x)); Constructor; Auto.
Cut (lookupR R r25)=O; Auto with arith.
Intros; Cut x=(nil int).
Intro EQ; Rewrite EQ.
Apply Compose_Slist_Pair_to_Slist with (lookupR R r28).
Rewrite EQ in H2.
Apply star_subst with (star (Slist (nil nat) (lookupR R r25) (0))
           (Slist x0 (lookupR R r26) (lookupR R r28)))
         (Pair (lookupR R r28) x1 (lookupR R r25)); Auto.
Clear H2; Intros.
Apply star_emp.
Apply star_subst with (Slist (nil nat) (lookupR R r25) (0))
         (Slist x0 (lookupR R r26) (lookupR R r28)); Auto.
Intro; Apply Slist_nil_empty.
Intros; Apply h_subst_Slist with H5; Auto.
Rewrite H3; Auto.
Rewrite H3 in H2.
Apply Star_Slist_O_O_nil with (H1,R)
	 (star (Slist x0 (lookupR R r26) (lookupR R r28))
	   (Pair (lookupR R r28) x1 O)).
Apply star_assoc_L; Auto.
Unfold T_test; Unfold T_next0; Intros.
Apply star_subst_sameR with [s:(heap*rfile)]
          ((getValinR s r28)=(0)
           ->(EX l:(list nat) | (Slist l (getValinR s r25) (0) s)/\l=l0)
             /\(getValinR s r26)=(0))
          /\(~(getValinR s r28)=(0)
             ->(EX la:(list nat) |
                  (EX lb:(list nat) |
                     (EX b:nat |
                        (star
                          (star (Slist la (getValinR s r25) (0))
                            (Slist lb (getValinR s r26)
                              (getValinR s r28)))
                          (Pair (getValinR s r28) b (getValinR s r25))
                          s)/\(app lb (cons b la))=l0))))
         (Good (getValinR (H,R) r2)); Auto.
Clear H1; Intros.
Unfold getValinR; Unfold getValinR in H2.
Inversion_clear H2; Constructor.
Intro; Cut (EX l:(list nat) | (Slist l (lookupR R r25) (0) (H1,R))/\l=l0)
         /\(lookupR R r26)=(0); Auto.
Clear H3; Clear H4; Intros.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H3.
Constructor; Auto.
Rewrite <- H6; Apply Unfold_Slist; Auto.
Intro EQO; Rewrite EQO in H0; Inversion H0.
Intro; Cut (EX la:(list nat) |
            (EX lb:(list nat) |
               (EX b:nat |
                  (star
                    (star (Slist la (lookupR R r25) (0))
                      (Slist lb (lookupR R r26) (lookupR R r28)))
                    (Pair (lookupR R r28) b (lookupR R r25)) (H1,R))
                  /\(app lb (cons b la))=l0))); Auto.
Clear H3; Clear H4; Intros.
SplitAllExs.
Inversion_clear H4.
Cut (EX a | (EX la | (EX i | (star
         (star
	   (star (Pair (lookupR R r25) a i) (Slist la i (0)))
           (Slist x0 (lookupR R r26) (lookupR R r28)))
         (Pair (lookupR R r28) x1 (lookupR R r25)) (H1,R))
	  /\(cons a la)=x))).
Clear H3; Intros.
SplitAllExs.
Inversion_clear H4.
Exists x2; Exists x3; Exists x0; Exists x1; Exists x4.
Rewrite <- H6 in H5; Constructor; Auto.
Cut (EX a:nat |
      (EX la:(list nat) |
         (EX i:nat |
            (star (star (Pair (lookupR R r25) a i) (Slist la i (0)))
              (star 
                (Slist x0 (lookupR R r26) (lookupR R r28))
		(Pair (lookupR R r28) x1 (lookupR R r25))) (H1,R))
            /\(cons a la)=x))).
Clear H3; Clear H5; Intros.
SplitAllExs.
Exists x2; Exists x3; Exists x4.
Inversion_clear H4; Constructor; Auto.
Apply star_assoc_R; Auto.
Apply Star_Unfold_Slist.
Apply star_assoc_L; Auto.
Intro EQO; Rewrite EQO in H0; Inversion H0.
(* jd halt *)
Apply I_jd with (T_halt l0); Auto.
CTLookupTac.
Save.

Lemma WF_next0 : (l0:(list int))
 (Infer (CT_Copy l0) (T_next0 l0) C_next0).
Proof.
Unfold C_next0; Intro.
(* movi nsize 2 *)
Apply I_movi with [s:state](T_next0 l0 s)/\(getValinR s nsize)=(2).
Unfold T_next0; Unfold updateR.
Intros.
Constructor.
Apply star_subst_diffR with R
 [s:(heap*rfile)]
          ((getValinR s r28)=(0)
           ->(EX b:nat |
                (EX l:(list nat) |
                   (EX i:nat |
                      (star (Pair (getValinR s r25) b i)
                        (Slist l i (0)) s)/\(cons b l)=l0)))
             /\(getValinR s r26)=(0))
          /\(~(getValinR s r28)=(0)
             ->(EX a:nat |
                  (EX la:(list nat) |
                     (EX lb:(list nat) |
                        (EX b:nat |
                           (EX i:nat |
                              (star
                                (star
                                  (star (Pair (getValinR s r25) a i)
                                    (Slist la i (0)))
                                  (Slist lb (getValinR s r26)
                                    (getValinR s r28)))
                                (Pair (getValinR s r28) b
                                  (getValinR s r25)) s)
                              /\(app lb (cons b (cons a la)))=l0))))))
         (Good (getValinR (H,R) r2)); Auto.
Clear H0; Intros.
Inversion_clear H1; Constructor.
Unfold getValinR; Unfold getValinR in H2; Clear H3.
Unfold lookupR; Fold lookupR; Unfold beq_reg.
Intro; Cut (EX b:nat |
            (EX l:(list nat) |
               (EX i:nat |
                  (star (Pair (lookupR R r25) b i) (Slist l i (0))
                    (H0,R))/\(cons b l)=l0)))/\(lookupR R r26)=(0); Auto.
Clear H2; Intro H2; Inversion_clear H2.
Constructor; Auto.
SplitAllExs.
Inversion_clear H2.
Exists x; Exists x0; Exists x1; Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply Pair_RF_Insensitive.
Intro; Apply Slist_RF_Insensitive.
Unfold getValinR in H3; Unfold getValinR; Clear H2.
Unfold lookupR; Fold lookupR; Unfold beq_reg.
Intro; Cut (EX a:nat |
            (EX la:(list nat) |
               (EX lb:(list nat) |
                  (EX b:nat |
                     (EX i:nat |
                        (star
                          (star
                            (star (Pair (lookupR R r25) a i)
                              (Slist la i (0)))
                            (Slist lb (lookupR R r26) (lookupR R r28)))
                          (Pair (lookupR R r28) b (lookupR R r25))
                          (H0,R))/\(app lb (cons b (cons a la)))=l0))))); Auto.
Clear H3; Intros.
SplitAllExs.
Inversion_clear H3.
Exists x; Exists x0; Exists x1; Exists x2; Exists x3; Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Clear H2; Intro; Apply RF_Insensitive_Distrib_Star.
Intro; Apply RF_Insensitive_Distrib_Star.
Intro; Apply Pair_RF_Insensitive.
Intro; Apply Slist_RF_Insensitive.
Intro; Apply Slist_RF_Insensitive.
Intro; Apply Pair_RF_Insensitive.
Unfold getValinR; Unfold lookupR; Fold lookupR; Unfold beq_reg.
Intro; Apply Good_RF_Insensitive.
Unfold getValinR; Unfold lookupR; Fold lookupR; Unfold beq_reg; Trivial.
(* movi ret1 next1 *)
Apply I_movi with [s:(heap*rfile)](T_next0 l0 s)/\(getValinR s r16)=(2)
			   /\(getValinR s ret1)=L_next1.
Unfold updateR; Unfold getValinR.
Unfold lookupR; Fold lookupR; Unfold beq_reg.
Unfold T_next0; Intros.
Inversion_clear H0.
Constructor; Auto.
Apply star_subst_diffR with R
[s:(heap*rfile)]
          ((getValinR s r28)=(0)
           ->(EX b:nat |
                (EX l:(list nat) |
                   (EX i:nat |
                      (star (Pair (getValinR s r25) b i)
                        (Slist l i (0)) s)/\(cons b l)=l0)))
             /\(getValinR s r26)=(0))
          /\(~(getValinR s r28)=(0)
             ->(EX a:nat |
                  (EX la:(list nat) |
                     (EX lb:(list nat) |
                        (EX b:nat |
                           (EX i:nat |
                              (star
                                (star
                                  (star (Pair (getValinR s r25) a i)
                                    (Slist la i (0)))
                                  (Slist lb (getValinR s r26)
                                    (getValinR s r28)))
                                (Pair (getValinR s r28) b
                                  (getValinR s r25)) s)
                              /\(app lb (cons b (cons a la)))=l0))))))
         (Good (getValinR (H,R) r2)); Auto.
Clear H1; Unfold getValinR; Intros.
Inversion_clear H1; Unfold lookupR; Fold lookupR; Unfold beq_reg.
Constructor.
Intro; Cut (EX b:nat |
            (EX l:(list nat) |
               (EX i:nat |
                  (star (Pair (lookupR R r25) b i) (Slist l i (0))
                    (H0,R))/\(cons b l)=l0)))/\(lookupR R r26)=(0); Auto.
Clear H3; Clear H4; Intros.
Inversion_clear H3.
SplitAllExs.
Inversion_clear H3.
Constructor; Auto.
Exists x; Exists x0; Exists x1; Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply Pair_RF_Insensitive.
Intro; Apply Slist_RF_Insensitive.
Apply imply_cut with (EX a:nat |
            (EX la:(list nat) |
               (EX lb:(list nat) |
                  (EX b:nat |
                     (EX i:nat |
                        (star
                          (star
                            (star (Pair (lookupR R r25) a i)
                              (Slist la i (0)))
                            (Slist lb (lookupR R r26) (lookupR R r28)))
                          (Pair (lookupR R r28) b (lookupR R r25))
                          (H0,R))/\(app lb (cons b (cons a la)))=l0))))); Auto.
Clear H3; Clear H4; Intros.
SplitAllExs.
Inversion_clear H3.
Exists x; Exists x0; Exists x1; Exists x2; Exists x3; Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply RF_Insensitive_Distrib_Star.
Intro; Apply RF_Insensitive_Distrib_Star.
Intro; Apply Pair_RF_Insensitive.
Intro; Apply Slist_RF_Insensitive.
Intro; Apply Slist_RF_Insensitive.
Intro; Apply Pair_RF_Insensitive.
Intro; Apply Good_RF_Insensitive.
(* jd malloc *)
Apply I_jd with (TT_malloc l0).
CTLookupTac.
Intros; Unfold TT_malloc.
SplitAllHyps; Unfold T_malloc.
Constructor; Auto.
Constructor; Auto.
Save.

Lemma WF_next1 : (l0:(list int))
 (Infer (CT_Copy l0) (T_next1 l0) C_next1).
Proof.
Intro; Unfold C_next1; Unfold T_next1.
(* ld temp src(0) *)
Apply I_ld with [s:(heap*rfile)]
 (EX lnk:nat |
   (EX siz:nat |
     (star
       (star
         [s0:(heap*rfile)]
         ((getValinR s0 r28)=(0)
          ->
           (EX l:(list nat) |
             (EX i:nat |
               (star (Pair (getValinR s0 r25) (getValinR s0 temp) i)
                 (Slist l i (0)) s0)/\(cons (getValinR s0 temp) l)=l0))
                  /\(getValinR s0 r26)=(0))
                  /\(~(getValinR s0 r28)=(0)
                  ->
           (EX la:(list nat) |
             (EX lb:(list nat) |
               (EX b:nat |
                 (EX i:nat |
                   (star
                     (star
                       (star
                         (Pair (getValinR s0 r25) (getValinR s0 temp) i)
                         (Slist la i (0)))
                       (Slist lb (getValinR s0 r26)
                         (getValinR s0 r28)))
                     (Pair (getValinR s0 r28) b
                       (getValinR s0 r25)) s0)
                        /\(app lb (cons b (cons (getValinR s0 temp) la)))=l0)))))
         (Good (getValinR s r2)))
       (MBlk (getValinR s r20) lnk siz) s)/\(le (4) siz))).
Intros.
Inversion_clear H0.
Cut (EX a | (EX siz:nat |
     (star
       (star
         [s:(heap*rfile)]
         ((getValinR s r28)=(0)
          ->
           (EX l:(list nat) |
             (EX i:nat |
               (star (Pair (getValinR s r25) a i)
                 (Slist l i (0)) s)/\(cons a l)=l0))
                  /\(getValinR s r26)=(0))
		  /\(~(getValinR s r28)=(0)
                  ->
           (EX la:(list nat) |
             (EX lb:(list nat) |
               (EX b:nat |
                 (EX i:nat |
                   (star
                     (star
                       (star
                         (Pair (getValinR s r25) a i)
                         (Slist la i (0)))
                       (Slist lb (getValinR s r26)
                         (getValinR s r28)))
                     (Pair (getValinR s r28) b
                       (getValinR s r25)) s)
                        /\(app lb (cons b (cons a la)))=l0)))))
         (Good (getValinR (H,R) r2)))
       (MBlk (getValinR (H,R) r20) x siz) (H,R))/\(le (4) siz))).
Clear H1; Intros.
SplitAllExs.
Exists x0.
Constructor.
Inversion_clear H0.
Apply Read_Star with R
 (star
   [s:(heap*rfile)]
   ((getValinR s r28)=(0)
    ->(EX l:(list nat) |
       (EX i:nat |
         (star (Pair (getValinR s r25) x0 i)
           (Slist l i (0)) s)/\(cons x0 l)=l0))
            /\(getValinR s r26)=(0))
            /\(~(getValinR s r28)=(0)
            ->(EX la:(list nat) |
       (EX lb:(list nat) |
         (EX b:nat |
           (EX i:nat |
             (star
               (star
                 (star (Pair (getValinR s r25) x0 i)
                   (Slist la i (0)))
                 (Slist lb (getValinR s r26)
                   (getValinR s r28)))
               (Pair (getValinR s r28) b
                 (getValinR s r25)) s)
                  /\(app lb (cons b (cons x0 la)))=l0)))))
   (Good (getValinR (H,R) r2)))
 (MBlk (getValinR (H,R) r20) x x1); Auto.
Clear H1; Intros.
Apply Read_Star with R 
[s:(heap*rfile)]
          ((getValinR s r28)=(0)
           ->(EX l:(list nat) |
                (EX i:nat |
                   (star (Pair (getValinR s r25) x0 i) (Slist l i (0))
                     s)/\(cons x0 l)=l0))/\(getValinR s r26)=(0))
          /\(~(getValinR s r28)=(0)
             ->(EX la:(list nat) |
                  (EX lb:(list nat) |
                     (EX b:nat |
                        (EX i:nat |
                           (star
                             (star
                               (star (Pair (getValinR s r25) x0 i)
                                 (Slist la i (0)))
                               (Slist lb (getValinR s r26)
                                 (getValinR s r28)))
                             (Pair (getValinR s r28) b
                               (getValinR s r25)) s)
                           /\(app lb (cons b (cons x0 la)))=l0)))))
         (Good (getValinR (H,R) r2)); Auto.
Clear H0; Intros.
Unfold getValinR in H0; Inversion_clear H0.
Compare (lookupR R r28) O.
Apply imply_cut with (EX l:(list nat) |
            (EX i:nat |
               (star (Pair (lookupR R r25) x0 i) (Slist l i (0))
                 (H'0,R))/\(cons x0 l)=l0))/\(lookupR R r26)=(0); Auto.
Clear H1; Clear H3; Intros.
Inversion_clear H0.
Inversion_clear H1.
Inversion_clear H0.
Inversion_clear H1.
Apply Read_Star with R (Pair (lookupR R r25) x0 x3) (Slist x2 x3 (0)); Auto.
Intro; Apply Read_Pair_val.
Apply imply_cut with (EX la:(list nat) |
            (EX lb:(list nat) |
               (EX b:nat |
                  (EX i:nat |
                     (star
                       (star
                         (star (Pair (lookupR R r25) x0 i)
                           (Slist la i (0)))
                         (Slist lb (lookupR R r26) (lookupR R r28)))
                       (Pair (lookupR R r28) b (lookupR R r25)) 
                      (H'0,R))/\(app lb (cons b (cons x0 la)))=l0)))); Auto.
Clear H1; Clear H3; Intros.
SplitAllExs.
Inversion_clear H0.
Apply Read_Star with R
	    (star (star (Pair (lookupR R r25) x0 x5) (Slist x2 x5 (0)))
              (Slist x3 (lookupR R r26) (lookupR R r28)))
            (Pair (lookupR R r28) x4 (lookupR R r25)); Auto.
Clear H1; Intros.
Apply Read_Star with R (star (Pair (lookupR R r25) x0 x5) (Slist x2 x5 (0)))
         (Slist x3 (lookupR R r26) (lookupR R r28)); Auto.
Clear H0; Intros.
Apply Read_Star with R (Pair (lookupR R r25) x0 x5) (Slist x2 x5 (0)); Auto.
Intro; Apply Read_Pair_val.
Exists x; Exists x1.
Inversion_clear H0; Constructor; Auto.
Apply star_subst_diffR with R
(star
           [s:(heap*rfile)]
            ((getValinR s r28)=(0)
             ->(EX l:(list nat) |
                  (EX i:nat |
                     (star (Pair (getValinR s r25) x0 i)
                       (Slist l i (0)) s)/\(cons x0 l)=l0))
               /\(getValinR s r26)=(0))
            /\(~(getValinR s r28)=(0)
               ->(EX la:(list nat) |
                    (EX lb:(list nat) |
                       (EX b:nat |
                          (EX i:nat |
                             (star
                               (star
                                 (star (Pair (getValinR s r25) x0 i)
                                   (Slist la i (0)))
                                 (Slist lb (getValinR s r26)
                                   (getValinR s r28)))
                               (Pair (getValinR s r28) b
                                 (getValinR s r25)) s)
                             /\(app lb (cons b (cons x0 la)))=l0)))))
           (Good (getValinR (H,R) r2)))
         (MBlk (getValinR (H,R) r20) x x1); Auto.
Clear H1; Intros.
Apply star_subst_diffR with R
[s:(heap*rfile)]
          ((getValinR s r28)=(0)
           ->(EX l:(list nat) |
                (EX i:nat |
                   (star (Pair (getValinR s r25) x0 i) (Slist l i (0))
                     s)/\(cons x0 l)=l0))/\(getValinR s r26)=(0))
          /\(~(getValinR s r28)=(0)
             ->(EX la:(list nat) |
                  (EX lb:(list nat) |
                     (EX b:nat |
                        (EX i:nat |
                           (star
                             (star
                               (star (Pair (getValinR s r25) x0 i)
                                 (Slist la i (0)))
                               (Slist lb (getValinR s r26)
                                 (getValinR s r28)))
                             (Pair (getValinR s r28) b
                               (getValinR s r25)) s)
                           /\(app lb (cons b (cons x0 la)))=l0)))))
         (Good (getValinR (H,R) r2)); Auto.
Clear H1; Unfold getValinR; Intros.
Unfold updateR; Unfold lookupR; Fold lookupR; Unfold beq_reg.
SplitAllHyps.
Constructor.
Apply imply_cut with (EX l:(list nat) |
            (EX i:nat |
               (star (Pair (lookupR R r25) x0 i) (Slist l i (0)) (H1,R))
               /\(cons x0 l)=l0))/\(lookupR R r26)=(0); Auto.
Clear H4; Clear H5; Intros.
SplitAllHyps.
SplitAllExs.
SplitAllHyps.
Constructor; Auto.
Exists x2; Exists x3; Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply Pair_RF_Insensitive.
Intro; Apply Slist_RF_Insensitive.
Apply imply_cut with (EX la:(list nat) |
            (EX lb:(list nat) |
               (EX b:nat |
                  (EX i:nat |
                     (star
                       (star
                         (star (Pair (lookupR R r25) x0 i)
                           (Slist la i (0)))
                         (Slist lb (lookupR R r26) (lookupR R r28)))
                       (Pair (lookupR R r28) b (lookupR R r25)) 
                      (H1,R))/\(app lb (cons b (cons x0 la)))=l0)))); Auto.
Clear H4; Clear H5; Intros.
SplitAllExs.
SplitAllHyps.
Exists x2; Exists x3; Exists x4; Exists x5; Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply RF_Insensitive_Distrib_Star.
Intro; Apply RF_Insensitive_Distrib_Star.
Intro; Apply Pair_RF_Insensitive.
Intro; Apply Slist_RF_Insensitive.
Intro; Apply Slist_RF_Insensitive.
Intro; Apply Pair_RF_Insensitive.
Intro; Apply Good_RF_Insensitive.
Intro; Apply MBlk_RF_Insensitive.
Inversion_clear H1.
Inversion_clear H0.
Cut (EX a:nat | (EX siz:nat |
         (star
             [s:(heap*rfile)]
              ((getValinR s r28)=(0)
               ->(EX l:(list nat) |
                    (EX i:nat |
                       (star (Pair (getValinR s r25) a i)
                         (Slist l i (0)) s)/\(cons a l)=l0))
                 /\(getValinR s r26)=(0))
              /\(~(getValinR s r28)=(0)
                 ->(EX la:(list nat) |
                      (EX lb:(list nat) |
                         (EX b:nat |
                            (EX i:nat |
                               (star
                                 (star
                                   (star (Pair (getValinR s r25) a i)
                                     (Slist la i (0)))
                                   (Slist lb (getValinR s r26)
                                     (getValinR s r28)))
                                 (Pair (getValinR s r28) b
                                   (getValinR s r25)) s)
                               /\(app lb (cons b (cons a la)))=l0)))))
           (star (Good (getValinR (H,R) r2))
           (MBlk (getValinR (H,R) r20) x siz)) (H,R))/\(le (4) siz))).
Clear H1; Intros.
SplitAllExs.
SplitAllHyps.
Exists x1; Exists x2; Constructor; Auto.
Apply star_assoc_R.
Apply star_subst with
[s:(heap*rfile)]
          ((getValinR s r28)=(0)
           ->(EX l:(list nat) |
                (EX i:nat |
                   (star (Pair (getValinR s r25) x1 i) (Slist l i (0))
                     s)/\(cons x1 l)=l0))/\(getValinR s r26)=(0))
          /\(~(getValinR s r28)=(0)
             ->(EX la:(list nat) |
                  (EX lb:(list nat) |
                     (EX b:nat |
                        (EX i:nat |
                           (star
                             (star
                               (star (Pair (getValinR s r25) x1 i)
                                 (Slist la i (0)))
                               (Slist lb (getValinR s r26)
                                 (getValinR s r28)))
                             (Pair (getValinR s r28) b
                               (getValinR s r25)) s)
                           /\(app lb (cons b (cons x1 la)))=l0)))))
         (star (Good (getValinR (H,R) r2))
           (MBlk (getValinR (H,R) r20) x x2)); Auto.
Cut (star [s:(heap*rfile)]
            ((getValinR s r28)=(0)
             ->(EX b:nat |
                  (EX l:(list nat) |
                     (EX i:nat |
                        (star (Pair (getValinR s r25) b i)
                          (Slist l i (0)) s)/\(cons b l)=l0)))
               /\(getValinR s r26)=(0))
            /\(~(getValinR s r28)=(0)
               ->(EX a:nat |
                    (EX la:(list nat) |
                       (EX lb:(list nat) |
                          (EX b:nat |
                             (EX i:nat |
                                (star
                                  (star
                                    (star (Pair (getValinR s r25) a i)
                                      (Slist la i (0)))
                                    (Slist lb (getValinR s r26)
                                      (getValinR s r28)))
                                  (Pair (getValinR s r28) b
                                    (getValinR s r25)) s)
                                /\(app lb (cons b (cons a la)))=l0))))))
         (star (Good (getValinR (H,R) r2))
         (MBlk (getValinR (H,R) r20) x x0)) (H,R)).
Clear H1; Intros.
Inversion_clear H0.
Inversion_clear H1.
SplitAllHyps.
Compare (getValinR (x1,R) r28) (0).
Intro; Apply imply_cut with (getValinR (x1,R) r28)=(0)
     (EX b:nat |
            (EX l:(list nat) |
               (EX i:nat |
                  (star (Pair (getValinR (x1,R) r25) b i)
                    (Slist l i (0)) (x1,R))/\(cons b l)=l0)))
         /\(getValinR (x1,R) r26)=(0); Auto.
Clear H4; Clear H6; Intros.
Inversion_clear H3.
Inversion_clear H4.
Exists x3; Exists x0.
Constructor; Auto.
Exists x1; Exists x2; Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Constructor; Intro;
	    [Constructor; Auto | Absurd (getValinR (x1,R) r28)=(0); Auto].
Intro; Apply imply_cut with ~(getValinR (x1,R) r28)=(0)
(EX a:nat |
            (EX la:(list nat) |
               (EX lb:(list nat) |
                  (EX b:nat |
                     (EX i:nat |
                        (star
                          (star
                            (star (Pair (getValinR (x1,R) r25) a i)
                              (Slist la i (0)))
                            (Slist lb (getValinR (x1,R) r26)
                              (getValinR (x1,R) r28)))
                          (Pair (getValinR (x1,R) r28) b
                            (getValinR (x1,R) r25)) (x1,R))
                        /\(app lb (cons b (cons a la)))=l0))))); Auto.
Clear H4; Clear H6; Intros.
Inversion_clear H3.
Exists x3; Exists x0.
Constructor; Auto.
Exists x1; Exists x2; Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Constructor; Intro;
	    [Absurd (getValinR (x1,R) r28)=(0); Auto | Auto].
Apply star_assoc_L; Auto.
(* st mptr(0) temp *)
Apply I_st with [s:(heap*rfile)]
    (star
      (star
        [s0:(heap*rfile)]
        ((getValinR s0 r28)=(0)
         ->(EX l:(list nat) |
            (EX i:nat |
              (star
                (Pair (getValinR s0 r25) (getValinR s0 r27)
                 i) (Slist l i (0)) s0)
                 /\(cons (getValinR s0 r27) l)=l0))
                 /\(getValinR s0 r26)=(0))
                 /\(~(getValinR s0 r28)=(0)
                 ->(EX la:(list nat) |
            (EX lb:(list nat) |
              (EX b:nat |
                (EX i:nat |
                  (star
                    (star
                      (star
                        (Pair (getValinR s0 r25)
                          (getValinR s0 r27) i)
                        (Slist la i (0)))
                      (Slist lb (getValinR s0 r26)
                        (getValinR s0 r28)))
                    (Pair (getValinR s0 r28) b
                      (getValinR s0 r25)) s0)
                       /\(app lb
                    (cons b
                      (cons (getValinR s0 r27) la)))
                       =l0))))) (Good (getValinR s r2)))
      ([s0:state](EX q | (Pair (getValinR s r20) (getValinR s r27) q s0)))
       s).
Intros.
SplitAllExs.
SplitAllHyps.
Cut (star (MBlk (getValinR (H,R) r20) x x0)
    (star
      [s0:(heap*rfile)]
      ((getValinR s0 r28)=(0)
       ->(EX l:(list nat) |
          (EX i:nat |
            (star
              (Pair (getValinR s0 r25) (getValinR s0 r27) i)
              (Slist l i (0)) s0)
               /\(cons (getValinR s0 r27) l)=l0))
               /\(getValinR s0 r26)=(0))
               /\(~(getValinR s0 r28)=(0)
               ->(EX la:(list nat) |
          (EX lb:(list nat) |
            (EX b:nat |
              (EX i:nat |
                (star
                  (star
                    (star
                      (Pair (getValinR s0 r25)
                        (getValinR s0 r27) i)
                      (Slist la i (0)))
                    (Slist lb (getValinR s0 r26)
                      (getValinR s0 r28)))
                  (Pair (getValinR s0 r28) b
                    (getValinR s0 r25)) s0)
                     /\(app lb
                  (cons b (cons (getValinR s0 r27) la)))
                   =l0))))) (Good (getValinR (H,R) r2))) (H,R)).
Clear H1; Intros.
Constructor.
Unfold plus.
Apply Star_MBlk_indom_0 with R x x0 (star
           [s0:(heap*rfile)]
            ((getValinR s0 r28)=(0)
             ->(EX l:(list nat) |
                  (EX i:nat |
                     (star
                       (Pair (getValinR s0 r25) (getValinR s0 r27) i)
                       (Slist l i (0)) s0)
                     /\(cons (getValinR s0 r27) l)=l0))
               /\(getValinR s0 r26)=(0))
            /\(~(getValinR s0 r28)=(0)
               ->(EX la:(list nat) |
                    (EX lb:(list nat) |
                       (EX b:nat |
                          (EX i:nat |
                             (star
                               (star
                                 (star
                                   (Pair (getValinR s0 r25)
                                     (getValinR s0 r27) i)
                                   (Slist la i (0)))
                                 (Slist lb (getValinR s0 r26)
                                   (getValinR s0 r28)))
                               (Pair (getValinR s0 r28) b
                                 (getValinR s0 r25)) s0)
                             /\(app lb
                                 (cons b (cons (getValinR s0 r27) la)))
                                =l0))))) (Good (getValinR (H,R) r2))); Auto.
Apply star_sym.
Apply Write_Star with (MBlk (getValinR (H,R) r20) x x0); Auto.
Clear H0; Intros.
Unfold getValinR in H0.
Unfold plus; Apply MBlk_indom_0 with R x x0; Auto.
Clear H0; Unfold getValinR; Intros.
Cut (EX val | (EX q | (Pair (lookupR R r20) val q (H',R)))).
Clear H0; Intros.
SplitAllExs.
Exists x2.
Unfold plus; Apply Write_Pair_val with x1; Auto.
Apply MBlk_Pair with x x0; Auto.
Apply star_sym; Auto.
(* mov fptr src *)
Apply I_mov with [s:(heap*rfile)]
      (star
        (star
          [s0:(heap*rfile)]
           ((getValinR s0 r28)=(0)
            ->(EX l:(list nat) |
                 (EX i:nat |
                    (star
                      (Pair (getValinR s0 r25) (getValinR s0 r27) i)
                      (Slist l i (0)) s0)
                    /\(cons (getValinR s0 r27) l)=l0))
              /\(getValinR s0 r26)=(0))
           /\(~(getValinR s0 r28)=(0)
              ->(EX la:(list nat) |
                   (EX lb:(list nat) |
                      (EX b:nat |
                         (EX i:nat |
                            (star
                              (star
                                (star
                                  (Pair (getValinR s0 r25)
                                    (getValinR s0 r27) i)
                                  (Slist la i (0)))
                                (Slist lb (getValinR s0 r26)
                                  (getValinR s0 r28)))
                              (Pair (getValinR s0 r28) b
                                (getValinR s0 r25)) s0)
                            /\(app lb
                                (cons b (cons (getValinR s0 r27) la)))
                               =l0))))) (Good (getValinR s r2)))
        [s0:(heap*rfile)]
         (EX q:nat | (Pair (getValinR s r20) (getValinR s r27) q s0)) s)
	  /\(getValinR s fptr)=(getValinR s src).
Intros; Unfold updateR; Constructor.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Clear H0; Intro; Apply RF_Insensitive_Distrib_Star.
Unfold getValinR; Unfold lookupR; Fold lookupR; Unfold beq_reg; Intros.
Inversion_clear H0.
Constructor.
Apply imply_cut with (EX l:(list nat) |
            (EX i:nat |
               (star (Pair (lookupR R r25) (lookupR R r27) i)
                 (Slist l i (0)) (H'0,R))/\(cons (lookupR R r27) l)=l0))
         /\(lookupR R r26)=(0); Auto.
Clear H1; Clear H2; Intros.
SplitAllHyps.
SplitAllExs.
Constructor; Auto.
Exists x; Exists x0.
Inversion_clear H1; Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply Pair_RF_Insensitive.
Intro; Apply Slist_RF_Insensitive.
Apply imply_cut with (EX la:(list nat) |
            (EX lb:(list nat) |
               (EX b:nat |
                  (EX i:nat |
                     (star
                       (star
                         (star (Pair (lookupR R r25) (lookupR R r27) i)
                           (Slist la i (0)))
                         (Slist lb (lookupR R r26) (lookupR R r28)))
                       (Pair (lookupR R r28) b (lookupR R r25)) 
                      (H'0,R))
                     /\(app lb (cons b (cons (lookupR R r27) la)))=l0)))); Auto.
Clear H1; Clear H2; Intros.
SplitAllExs.
Exists x; Exists x0; Exists x1; Exists x2.
Inversion_clear H0; Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Clear H1; Intro; Apply RF_Insensitive_Distrib_Star.
Intro; Apply RF_Insensitive_Distrib_Star.
Intro; Apply Pair_RF_Insensitive.
Intro; Apply Slist_RF_Insensitive.
Intro; Apply Slist_RF_Insensitive.
Intro; Apply Pair_RF_Insensitive.
Intro; Apply Good_RF_Insensitive.
Unfold getValinR; Unfold lookupR; Fold lookupR; Unfold beq_reg; Clear H0.
Intros; Inversion_clear H0.
Exists x.
Apply Pair_RF_Insensitive with R; Auto.
Unfold getValinR; Unfold lookupR; Fold lookupR; Unfold beq_reg; Auto.
(* ld src src(1) *)
Apply I_ld with [s:(heap*rfile)]
    (star
      (star
        [s0:(heap*rfile)]
        ((getValinR s0 r28)=(0)
         ->(EX l:(list nat) |
            (star
              (Pair (getValinR s0 r3) (getValinR s0 r27) (getValinR s0 r25))
              (Slist l (getValinR s0 r25) (0)) s0)
               /\(cons (getValinR s0 r27) l)=l0)
               /\(getValinR s0 r26)=(0))
               /\(~(getValinR s0 r28)=(0)
               ->(EX la:(list nat) |
            (EX lb:(list nat) |
              (EX b:nat |
                (star
                  (star
                    (star
                      (Pair (getValinR s0 r3)
                        (getValinR s0 r27) (getValinR s0 r25))
                      (Slist la (getValinR s0 r25) (0)))
                    (Slist lb (getValinR s0 r26)
                      (getValinR s0 r28)))
                  (Pair (getValinR s0 r28) b
                    (getValinR s0 r3)) s0)
                     /\(app lb
                  (cons b (cons (getValinR s0 r27) la)))
                   =l0)))) (Good (getValinR s r2)))
      [s0:(heap*rfile)]
      (EX q:nat | (Pair (getValinR s r20) (getValinR s r27) q s0)) s).
Unfold updateR; Intros.
Inversion_clear H0.
Unfold getValinR in H2.
Cut (EX i | (star
         (star
           [s0:(heap*rfile)]
            ((getValinR s0 r28)=(0)
             ->(EX l:(list nat) |
                     (star
                       (Pair (getValinR s0 r25) (getValinR s0 r27) i)
                       (Slist l i (0)) s0)
                     /\(cons (getValinR s0 r27) l)=l0)
               /\(getValinR s0 r26)=(0))
            /\(~(getValinR s0 r28)=(0)
               ->(EX la:(list nat) |
                    (EX lb:(list nat) |
                       (EX b:nat |
                             (star
                               (star
                                 (star
                                   (Pair (getValinR s0 r25)
                                     (getValinR s0 r27) i)
                                   (Slist la i (0)))
                                 (Slist lb (getValinR s0 r26)
                                   (getValinR s0 r28)))
                               (Pair (getValinR s0 r28) b
                                 (getValinR s0 r25)) s0)
                             /\(app lb
                                 (cons b (cons (getValinR s0 r27) la)))
                                =l0)))) (Good (getValinR (H,R) r2)))
         [s0:(heap*rfile)]
          (EX q:nat |
             (Pair (getValinR (H,R) r20) (getValinR (H,R) r27) q s0))
         (H,R))).
Clear H1; Intro.
Inversion_clear H0.
Exists x; Constructor.
Apply Read_Star with R 
(star
           [s0:(heap*rfile)]
            ((getValinR s0 r28)=(0)
             ->(EX l:(list nat) |
                  (star (Pair (getValinR s0 r25) (getValinR s0 r27) x)
                    (Slist l x (0)) s0)/\(cons (getValinR s0 r27) l)=l0)
               /\(getValinR s0 r26)=(0))
            /\(~(getValinR s0 r28)=(0)
               ->(EX la:(list nat) |
                    (EX lb:(list nat) |
                       (EX b:nat |
                          (star
                            (star
                              (star
                                (Pair (getValinR s0 r25)
                                  (getValinR s0 r27) x)
                                (Slist la x (0)))
                              (Slist lb (getValinR s0 r26)
                                (getValinR s0 r28)))
                            (Pair (getValinR s0 r28) b
                              (getValinR s0 r25)) s0)
                          /\(app lb
                              (cons b (cons (getValinR s0 r27) la)))=l0))))
           (Good (getValinR (H,R) r2)))
         [s0:(heap*rfile)]
          (EX q:nat |
             (Pair (getValinR (H,R) r20) (getValinR (H,R) r27) q s0)); Auto.
Clear H1; Intros.
Apply Read_Star with R
[s0:(heap*rfile)]
          ((getValinR s0 r28)=(0)
           ->(EX l:(list nat) |
                (star (Pair (getValinR s0 r25) (getValinR s0 r27) x)
                  (Slist l x (0)) s0)/\(cons (getValinR s0 r27) l)=l0)
             /\(getValinR s0 r26)=(0))
          /\(~(getValinR s0 r28)=(0)
             ->(EX la:(list nat) |
                  (EX lb:(list nat) |
                     (EX b:nat |
                        (star
                          (star
                            (star
                              (Pair (getValinR s0 r25)
                                (getValinR s0 r27) x) (Slist la x (0)))
                            (Slist lb (getValinR s0 r26)
                              (getValinR s0 r28)))
                          (Pair (getValinR s0 r28) b (getValinR s0 r25))
                          s0)
                        /\(app lb (cons b (cons (getValinR s0 r27) la)))
                           =l0)))) (Good (getValinR (H,R) r2)); Auto.
Clear H0; Intros.
Unfold getValinR in H0; Inversion_clear H0.
Compare (lookupR R r28) O.
Apply imply_cut with (EX l:(list nat) |
            (star (Pair (lookupR R r25) (lookupR R r27) x)
              (Slist l x (0)) (H'0,R))/\(cons (lookupR R r27) l)=l0)
         /\(lookupR R r26)=(0); Auto.
Clear H1; Clear H3; Intros.
SplitAllHyps.
SplitAllExs.
SplitAllHyps.
Apply Read_Star with R (Pair (lookupR R r25) (lookupR R r27) x) (Slist x0 x (0)); Auto.
Clear H1; Intros.
Apply Read_Pair_lnk with R (lookupR R r27); Auto.
Apply imply_cut with (EX la:(list nat) |
            (EX lb:(list nat) |
               (EX b:nat |
                  (star
                    (star
                      (star (Pair (lookupR R r25) (lookupR R r27) x)
                        (Slist la x (0)))
                      (Slist lb (lookupR R r26) (lookupR R r28)))
                    (Pair (lookupR R r28) b (lookupR R r25)) (H'0,R))
                  /\(app lb (cons b (cons (lookupR R r27) la)))=l0))); Auto.
Clear H1; Clear H3; Intros.
SplitAllExs.
SplitAllHyps.
Apply Read_Star with R
(star
           (star (Pair (lookupR R r25) (lookupR R r27) x)
             (Slist x0 x (0)))
           (Slist x1 (lookupR R r26) (lookupR R r28)))
         (Pair (lookupR R r28) x2 (lookupR R r25)); Auto.
Clear H0; Intros.
Apply Read_Star with R (star (Pair (lookupR R r25) (lookupR R r27) x)
           (Slist x0 x (0))) (Slist x1 (lookupR R r26) (lookupR R r28)); Auto.
Clear H0; Intros.
Apply Read_Star with R (Pair (lookupR R r25) (lookupR R r27) x) (Slist x0 x (0)); Auto.
Clear H0; Intro; Apply Read_Pair_lnk.
Apply star_subst_diffR with R 
(star
           [s0:(heap*rfile)]
            ((getValinR s0 r28)=(0)
             ->(EX l:(list nat) |
                  (star (Pair (getValinR s0 r25) (getValinR s0 r27) x)
                    (Slist l x (0)) s0)/\(cons (getValinR s0 r27) l)=l0)
               /\(getValinR s0 r26)=(0))
            /\(~(getValinR s0 r28)=(0)
               ->(EX la:(list nat) |
                    (EX lb:(list nat) |
                       (EX b:nat |
                          (star
                            (star
                              (star
                                (Pair (getValinR s0 r25)
                                  (getValinR s0 r27) x)
                                (Slist la x (0)))
                              (Slist lb (getValinR s0 r26)
                                (getValinR s0 r28)))
                            (Pair (getValinR s0 r28) b
                              (getValinR s0 r25)) s0)
                          /\(app lb
                              (cons b (cons (getValinR s0 r27) la)))=l0))))
           (Good (getValinR (H,R) r2)))
         [s0:(heap*rfile)]
          (EX q:nat |
             (Pair (getValinR (H,R) r20) (getValinR (H,R) r27) q s0)); Auto.
Clear H1; Intros.
Apply star_subst_diffR with R 
[s0:(heap*rfile)]
          ((getValinR s0 r28)=(0)
           ->(EX l:(list nat) |
                (star (Pair (getValinR s0 r25) (getValinR s0 r27) x)
                  (Slist l x (0)) s0)/\(cons (getValinR s0 r27) l)=l0)
             /\(getValinR s0 r26)=(0))
          /\(~(getValinR s0 r28)=(0)
             ->(EX la:(list nat) |
                  (EX lb:(list nat) |
                     (EX b:nat |
                        (star
                          (star
                            (star
                              (Pair (getValinR s0 r25)
                                (getValinR s0 r27) x) (Slist la x (0)))
                            (Slist lb (getValinR s0 r26)
                              (getValinR s0 r28)))
                          (Pair (getValinR s0 r28) b (getValinR s0 r25))
                          s0)
                        /\(app lb (cons b (cons (getValinR s0 r27) la)))
                           =l0)))) (Good (getValinR (H,R) r2)); Auto.
Clear H1; Intros.
Unfold getValinR; Unfold getValinR in H3; Inversion_clear H3.
Unfold lookupR; Fold lookupR; Unfold beq_reg; Constructor.
Apply imply_cut with (EX l:(list nat) |
            (star (Pair (lookupR R r25) (lookupR R r27) x)
              (Slist l x (0)) (H1,R))/\(cons (lookupR R r27) l)=l0)
         /\(lookupR R r26)=(0); Auto.
Clear H4; Clear H5; Intros.
SplitAllHyps; Constructor; Auto.
Inversion_clear H4.
SplitAllHyps; Exists x0; Constructor; Auto.
Rewrite H2.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply Pair_RF_Insensitive.
Intro; Apply Slist_RF_Insensitive.
Apply imply_cut with (EX la:(list nat) |
            (EX lb:(list nat) |
               (EX b:nat |
                  (star
                    (star
                      (star (Pair (lookupR R r25) (lookupR R r27) x)
                        (Slist la x (0)))
                      (Slist lb (lookupR R r26) (lookupR R r28)))
                    (Pair (lookupR R r28) b (lookupR R r25)) (H1,R))
                  /\(app lb (cons b (cons (lookupR R r27) la)))=l0))); Auto.
Clear H4; Clear H5; Intros.
SplitAllExs.
SplitAllHyps.
Exists x0; Exists x1; Exists x2; Constructor; Auto.
Rewrite H2.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply RF_Insensitive_Distrib_Star.
Intro; Apply RF_Insensitive_Distrib_Star.
Intro; Apply Pair_RF_Insensitive.
Intro; Apply Slist_RF_Insensitive.
Intro; Apply Slist_RF_Insensitive.
Intro; Apply Pair_RF_Insensitive.
Intro; Apply Good_RF_Insensitive.
Clear H1; Intros.
Inversion_clear H1.
Exists x0.
Apply Pair_RF_Insensitive with R; Auto.
Cut (star
              [s0:(heap*rfile)]
            ((getValinR s0 r28)=(0)
             ->(EX l:(list nat) |
                  (EX i:nat |
                     (star
                       (Pair (getValinR s0 r25) (getValinR s0 r27) i)
                       (Slist l i (0)) s0)
                     /\(cons (getValinR s0 r27) l)=l0))
               /\(getValinR s0 r26)=(0))
            /\(~(getValinR s0 r28)=(0)
               ->(EX la:(list nat) |
                    (EX lb:(list nat) |
                       (EX b:nat |
                          (EX i:nat |
                             (star
                               (star
                                 (star
                                   (Pair (getValinR s0 r25)
                                     (getValinR s0 r27) i)
                                   (Slist la i (0)))
                                 (Slist lb (getValinR s0 r26)
                                   (getValinR s0 r28)))
                               (Pair (getValinR s0 r28) b
                                 (getValinR s0 r25)) s0)
                             /\(app lb
                                 (cons b (cons (getValinR s0 r27) la)))
                                =l0)))))
		     (star
		       (Good (getValinR (H,R) r2))
		       [s0:(heap*rfile)]
		       (EX q:nat |
	(Pair (getValinR (H,R) r20) (getValinR (H,R) r27) q s0)))
		     (H,R)).
Clear H1;Intro.
Inversion_clear H0.
Inversion_clear H1.
Unfold getValinR in H0.
SplitAllHyps.
Compare (lookupR R r28) (0); Intro.
Apply imply_cut with ((lookupR R r28)=O) (EX l:(list nat) |
            (EX i:nat |
               (star (Pair (lookupR R r25) (lookupR R r27) i)
                 (Slist l i (0)) (x,R))/\(cons (lookupR R r27) l)=l0))
         /\(lookupR R r26)=(0); Auto.
Clear H4; Clear H6; Intro.
Inversion_clear H3.
SplitAllExs.
Exists x2.
Apply star_assoc_R.
Exists x; Exists x0.
Unfold getValinR.
Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Constructor.
Intro; Constructor; Auto.
Exists x1; Auto.
Intro; Absurd ((lookupR R r28)=O); Auto.
Apply imply_cut with (~(lookupR R r28)=(0))
(EX la:(list nat) |
            (EX lb:(list nat) |
               (EX b:nat |
                  (EX i:nat |
                     (star
                       (star
                         (star (Pair (lookupR R r25) (lookupR R r27) i)
                           (Slist la i (0)))
                         (Slist lb (lookupR R r26) (lookupR R r28)))
                       (Pair (lookupR R r28) b (lookupR R r25)) 
                      (x,R))
                     /\(app lb (cons b (cons (lookupR R r27) la)))=l0)))); Auto.
Clear H4; Clear H6; Intro.
SplitAllExs.
Exists x4.
Apply star_assoc_R.
Exists x; Exists x0; Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Unfold getValinR; Constructor.
Intro; Absurd (lookupR R r28)=(0); Auto.
Intro; Exists x1; Exists x2; Exists x3.
Auto.
Apply star_assoc_L; Auto.
(* st mptr(1) src *)
Apply I_st with [s:(heap*rfile)]
      (star
        (star
          [s0:(heap*rfile)]
           ((getValinR s0 r28)=(0)
            ->(EX l:(list nat) |
                 (star
                   (Pair (getValinR s0 r3) (getValinR s0 r27)
                     (getValinR s0 r25))
                   (Slist l (getValinR s0 r25) (0)) s0)
                 /\(cons (getValinR s0 r27) l)=l0)
              /\(getValinR s0 r26)=(0))
           /\(~(getValinR s0 r28)=(0)
              ->(EX la:(list nat) |
                   (EX lb:(list nat) |
                      (EX b:nat |
                         (star
                           (star
                             (star
                               (Pair (getValinR s0 r3)
                                 (getValinR s0 r27) (getValinR s0 r25))
                               (Slist la (getValinR s0 r25) (0)))
                             (Slist lb (getValinR s0 r26)
                               (getValinR s0 r28)))
                           (Pair (getValinR s0 r28) b (getValinR s0 r3))
                           s0)
                         /\(app lb
                             (cons b (cons (getValinR s0 r27) la)))=l0))))
          (Good (getValinR s r2)))
        [s0:(heap*rfile)]
         (Pair (getValinR s r20) (getValinR s r27) (getValinR s r25) s0) s).
Intros.
Cut (star
         [s0:(heap*rfile)]
          (EX q:nat |
             (Pair (getValinR (H,R) r20) (getValinR (H,R) r27) q s0))
         (star
           [s0:(heap*rfile)]
            ((getValinR s0 r28)=(0)
             ->(EX l:(list nat) |
                  (star
                    (Pair (getValinR s0 r3) (getValinR s0 r27)
                      (getValinR s0 r25))
                    (Slist l (getValinR s0 r25) (0)) s0)
                  /\(cons (getValinR s0 r27) l)=l0)
               /\(getValinR s0 r26)=(0))
            /\(~(getValinR s0 r28)=(0)
               ->(EX la:(list nat) |
                    (EX lb:(list nat) |
                       (EX b:nat |
                          (star
                            (star
                              (star
                                (Pair (getValinR s0 r3)
                                  (getValinR s0 r27) (getValinR s0 r25))
                                (Slist la (getValinR s0 r25) (0)))
                              (Slist lb (getValinR s0 r26)
                                (getValinR s0 r28)))
                            (Pair (getValinR s0 r28) b
                              (getValinR s0 r3)) s0)
                          /\(app lb
                              (cons b (cons (getValinR s0 r27) la)))=l0))))
           (Good (getValinR (H,R) r2)))
         (H,R)).
Clear H0; Intro.
Constructor.
Unfold plus; Apply indom_star with R
[s0:(heap*rfile)]
          (EX q:nat |
             (Pair (getValinR (H,R) r20) (getValinR (H,R) r27) q s0))
         (star
           [s0:(heap*rfile)]
            ((getValinR s0 r28)=(0)
             ->(EX l:(list nat) |
                  (star
                    (Pair (getValinR s0 r3) (getValinR s0 r27)
                      (getValinR s0 r25))
                    (Slist l (getValinR s0 r25) (0)) s0)
                  /\(cons (getValinR s0 r27) l)=l0)
               /\(getValinR s0 r26)=(0))
            /\(~(getValinR s0 r28)=(0)
               ->(EX la:(list nat) |
                    (EX lb:(list nat) |
                       (EX b:nat |
                          (star
                            (star
                              (star
                                (Pair (getValinR s0 r3)
                                  (getValinR s0 r27) (getValinR s0 r25))
                                (Slist la (getValinR s0 r25) (0)))
                              (Slist lb (getValinR s0 r26)
                                (getValinR s0 r28)))
                            (Pair (getValinR s0 r28) b
                              (getValinR s0 r3)) s0)
                          /\(app lb
                              (cons b (cons (getValinR s0 r27) la)))=l0))))
           (Good (getValinR (H,R) r2))); Auto.
Clear H0; Intros.
Inversion_clear H0.
Unfold Pair in H1.
SplitAllExs.
SplitAllHyps.
Apply MBlk_indom_1 with R x0 x1; Auto.
Apply star_sym.
Apply Write_Star with
[s0:(heap*rfile)]
          (EX q:nat |
             (Pair (getValinR (H,R) r20) (getValinR (H,R) r27) q s0)); Auto.
Clear H0; Intros.
Unfold Pair in H0.
SplitAllExs.
SplitAllHyps.
Unfold plus; Apply MBlk_indom_1 with R x0 x1; Auto.
Clear H0; Intros.
Inversion_clear H0.
Unfold getValinR; Unfold getValinR in H1.
Apply Write_Pair_lnk with x; Auto.
Apply star_sym; Auto.
(* movi ret0 next2 *)
Apply I_movi with [s:(heap*rfile)]
      (star
        (star
          [s0:(heap*rfile)]
           ((getValinR s0 r28)=(0)
            ->(EX a | (EX l:(list nat) |
                 (star
                   (Pair (getValinR s0 r20) a
                     (getValinR s0 r25))
                   (Slist l (getValinR s0 r25) (0)) s0)
                 /\(cons a l)=l0))
              /\(getValinR s0 r26)=(0))
           /\(~(getValinR s0 r28)=(0)
              ->(EX a | (EX la:(list nat) |
                   (EX lb:(list nat) |
                      (EX b:nat |
                         (star
                           (star
                             (star
                               (Pair (getValinR s0 r20)
                                 a (getValinR s0 r25))
                               (Slist la (getValinR s0 r25) (0)))
                             (Slist lb (getValinR s0 r26)
                               (getValinR s0 r28)))
                           (Pair (getValinR s0 r28) b (getValinR s0 r3))
                           s0)
                         /\(app lb
                             (cons b (cons a la)))=l0)))))
          (Good (getValinR s r2)))
        [s0:(heap*rfile)] (EX lnk | (EX siz |
         (MBlk (getValinR s r3) lnk siz s0)))
        s) /\ (getValinR s ret0)=L_next2.
Intros.
Constructor.
Apply star_sym.
Apply star_assoc_L.
Apply star_subst_diffR with R
(star [s0:(heap*rfile)]
          (Pair (getValinR (H,R) r20) (getValinR (H,R) r27)
            (getValinR (H,R) r25) s0)
           [s0:(heap*rfile)]
            ((getValinR s0 r28)=(0)
             ->(EX l:(list nat) |
                  (star
                    (Pair (getValinR s0 r3) (getValinR s0 r27)
                      (getValinR s0 r25))
                    (Slist l (getValinR s0 r25) (0)) s0)
                  /\(cons (getValinR s0 r27) l)=l0)
               /\(getValinR s0 r26)=(0))
            /\(~(getValinR s0 r28)=(0)
               ->(EX la:(list nat) |
                    (EX lb:(list nat) |
                       (EX b:nat |
                          (star
                            (star
                              (star
                                (Pair (getValinR s0 r3)
                                  (getValinR s0 r27) (getValinR s0 r25))
                                (Slist la (getValinR s0 r25) (0)))
                              (Slist lb (getValinR s0 r26)
                                (getValinR s0 r28)))
                            (Pair (getValinR s0 r28) b
                              (getValinR s0 r3)) s0)
                          /\(app lb
                              (cons b (cons (getValinR s0 r27) la)))=l0)))))
		  (Good (getValinR (H,R) r2)).
Clear H0; Intros.
Cut (star
    (Pair (lookupR R r20) (lookupR R r27) (lookupR R r25))
    [s0:state]
    ((lookupR R r28)=(0)
     ->(EX l:(list nat) |
        (star
          (Pair (lookupR R r3) (lookupR R r27)
            (lookupR R r25))
          (Slist l (lookupR R r25) (0)) s0)
           /\(cons (lookupR R r27) l)=l0)
           /\(lookupR R r26)=(0))
     /\(~(lookupR R r28)=(0)
           ->(EX la:(list nat) |
        (EX lb:(list nat) |
          (EX b:nat |
            (star
              (star
                (star
                  (Pair (lookupR R r3)
                    (lookupR R r27) (lookupR R r25))
                              (Slist la (lookupR R r25) (0)))
                            (Slist lb (lookupR R r26)
                              (lookupR R r28)))
                          (Pair (lookupR R r28) b (lookupR R r3))
                          s0)
                        /\(app lb (cons b (cons (lookupR R r27) la)))
                           =l0)))) (H0,R)).
Clear H1; Intro.
Compare (lookupR R r28) O; Intro.
Cut (star (Pair (lookupR R r20) (lookupR R r27) (lookupR R r25))
         [s0:(heap*rfile)]
         (EX l:(list nat) |
           (star
             (Pair (lookupR R r3) (lookupR R r27) (lookupR R r25))
             (Slist l (lookupR R r25) (0)) s0)
              /\(cons (lookupR R r27) l)=l0)/\(lookupR R r26)=(0)
	 (H0,R)).
Clear H1; Intro.
Cut (star
     [s0:(heap*rfile)]
      (EX lnk:nat |
         (EX siz:nat |
            (MBlk (getValinR (H,(updateR R r0 (29))) r3) lnk siz s0)))
     [s0:(heap*rfile)]
     (EX a:nat |
       (EX l:(list nat) |
         (star (Pair (getValinR s0 r20) a (getValinR s0 r25))
           (Slist l (getValinR s0 r25) (0)) s0)/\(cons a l)=l0))
            /\(getValinR s0 r26)=(0)
     (H0,(updateR R r0 (29)))).
Clear H1; Intros.
Apply star_subst_sameR with
[s0:(heap*rfile)]
          (EX lnk:nat |
             (EX siz:nat |
                (MBlk (getValinR (H,(updateR R r0 (29))) r3) lnk siz s0)))
         [s0:(heap*rfile)]
          (EX a:nat |
             (EX l:(list nat) |
                (star (Pair (getValinR s0 r20) a (getValinR s0 r25))
                  (Slist l (getValinR s0 r25) (0)) s0)/\(cons a l)=l0))
          /\(getValinR s0 r26)=(0); Auto.
Clear H1; Unfold updateR; Unfold getValinR.
Unfold lookupR; Fold lookupR; Unfold beq_reg; Intros.
Constructor; Intro; [Auto | Absurd (lookupR R r28)=(0); Auto].
Cut (star
     [s0:(heap*rfile)]
      (EX lnk:nat |
         (EX siz:nat |
            (MBlk (lookupR R r3) lnk siz s0)))
     [s0:(heap*rfile)]
      (EX a:nat |
         (EX l:(list nat) |
            (star (Pair (lookupR R r20) a (lookupR R r25))
              (Slist l (lookupR R r25) (0)) s0)/\(cons a l)=l0))
      /\(lookupR R r26)=(0) (H0,(updateR R r0 (29)))).
Clear H1; Intro.
Inversion_clear H1.
Inversion_clear H2.
SplitAllHyps.
Exists x; Exists x0.
Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R.
Clear H1; Intros.
SplitAllExs.
Exists x; Exists x0.
Apply MBlk_RF_Insensitive with R; Auto.
Clear H1; Intros.
Inversion_clear H1; Constructor; Auto.
SplitAllExs.
Exists x; Exists x0.
Inversion_clear H2; Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply Pair_RF_Insensitive.
Intro; Apply Slist_RF_Insensitive.
Cut (EX l:(list nat) |
	(star (Pair (lookupR R r20) (lookupR R r27) (lookupR R r25))
          (star
            (Pair (lookupR R r3) (lookupR R r27) (lookupR R r25))
            (Slist l (lookupR R r25) (0))) (H0,R))
             /\(cons (lookupR R r27) l)=l0)/\(lookupR R r26)=(0).
Clear H1; Intro.
Inversion_clear H1.
Inversion_clear H2.
Inversion_clear H1.
Cut (star (Pair (lookupR R r3) (lookupR R r27) (lookupR R r25))
        (star (Pair (lookupR R r20) (lookupR R r27) (lookupR R r25))
          (Slist x (lookupR R r25) (0))) (H0,R)).
Clear H2; Intro.
Apply star_subst with (Pair (lookupR R r3) (lookupR R r27) (lookupR R r25))
         (star (Pair (lookupR R r20) (lookupR R r27) (lookupR R r25))
           (Slist x (lookupR R r25) (0))); Auto.
Intro; Apply Pair_MBlk.
Clear H1; Intros.
Constructor; Auto.
Exists (lookupR R r27); Exists x; Constructor; Auto.
Apply star_assoc_L.
Apply star_subst with
	 (star  (Pair (lookupR R r20) (lookupR R r27) (lookupR R r25))
	   (Pair (lookupR R r3) (lookupR R r27) (lookupR R r25)))
	 (Slist x (lookupR R r25) (0)); Auto.
Apply star_assoc_R; Auto.
Intro; Apply star_sym.
Inversion_clear H1.
Inversion_clear H2.
SplitAllHyps.
Inversion_clear H4.
Constructor; Auto.
Inversion_clear H5; Exists x1; Constructor; Auto.
Exists x; Exists x0; Constructor; Auto.
Apply star_subst with (Pair (lookupR R r20) (lookupR R r27) (lookupR R r25))
         [s0:(heap*rfile)]
          ((lookupR R r28)=(0)
           ->(EX l:(list nat) |
                (star
                  (Pair (lookupR R r3) (lookupR R r27) (lookupR R r25))
                  (Slist l (lookupR R r25) (0)) s0)
                /\(cons (lookupR R r27) l)=l0)/\(lookupR R r26)=(0))
          /\(~(lookupR R r28)=(0)
             ->(EX la:(list nat) |
                  (EX lb:(list nat) |
                     (EX b:nat |
                        (star
                          (star
                            (star
                              (Pair (lookupR R r3) (lookupR R r27)
                                (lookupR R r25))
                              (Slist la (lookupR R r25) (0)))
                            (Slist lb (lookupR R r26) (lookupR R r28)))
                          (Pair (lookupR R r28) b (lookupR R r3)) s0)
                        /\(app lb (cons b (cons (lookupR R r27) la)))
                           =l0)))); Auto.
Clear H1; Intros.
Inversion_clear H1; Auto.
Cut (star (Pair (lookupR R r20) (lookupR R r27) (lookupR R r25))
         [s0:(heap*rfile)]
             (EX la:(list nat) |
                  (EX lb:(list nat) |
                     (EX b:nat |
                        (star
                          (star
                            (star
                              (Pair (lookupR R r3) (lookupR R r27)
                                (lookupR R r25))
                              (Slist la (lookupR R r25) (0)))
                            (Slist lb (lookupR R r26) (lookupR R r28)))
                          (Pair (lookupR R r28) b (lookupR R r3)) s0)
                        /\(app lb (cons b (cons (lookupR R r27) la)))
                           =l0))) (H0,R)).
Clear H1; Intro.
Cut (star
     [s0:(heap*rfile)]
      (EX lnk:nat |
         (EX siz:nat |
            (MBlk (getValinR (H,(updateR R r0 (29))) r3) lnk siz s0)))
     [s0:(heap*rfile)]
         (EX a:nat |
              (EX la:(list nat) |
                 (EX lb:(list nat) |
                    (EX b:nat |
                       (star
                         (star
                           (star
                             (Pair (getValinR s0 r20) a
                               (getValinR s0 r25))
                             (Slist la (getValinR s0 r25) (0)))
                           (Slist lb (getValinR s0 r26)
                             (getValinR s0 r28)))
                         (Pair (getValinR s0 r28) b (getValinR s0 r3))
                         s0)/\(app lb (cons b (cons a la)))=l0))))
     (H0,(updateR R r0 (29)))).
Clear H1; Intro.
Apply star_subst_sameR with
[s0:(heap*rfile)]
          (EX lnk:nat |
             (EX siz:nat |
                (MBlk (getValinR (H,(updateR R r0 (29))) r3) lnk siz s0)))
         [s0:(heap*rfile)]
          (EX a:nat |
               (EX la:(list nat) |
                  (EX lb:(list nat) |
                     (EX b:nat |
                        (star
                          (star
                            (star
                              (Pair (getValinR s0 r20) a
                                (getValinR s0 r25))
                              (Slist la (getValinR s0 r25) (0)))
                            (Slist lb (getValinR s0 r26)
                              (getValinR s0 r28)))
                          (Pair (getValinR s0 r28) b (getValinR s0 r3))
                          s0)/\(app lb (cons b (cons a la)))=l0)))); Auto.
Clear H1; Unfold updateR; Unfold getValinR.
Unfold lookupR; Fold lookupR; Unfold beq_reg; Intros.
Constructor; Intro; [Absurd (lookupR R r28)=(0); Auto | Auto].
Cut (star
     [s0:(heap*rfile)]
      (EX lnk:nat |
         (EX siz:nat |
            (MBlk (lookupR R r3) lnk siz s0)))
     [s0:(heap*rfile)]
      (EX a:nat |
           (EX la:(list nat) |
              (EX lb:(list nat) |
                 (EX b:nat |
                    (star
                      (star
                        (star
                          (Pair (lookupR R r20) a (lookupR R r25))
                          (Slist la (lookupR R r25) (0)))
                        (Slist lb (lookupR R r26) (lookupR R r28)))
                      (Pair (lookupR R r28) b (lookupR R r3)) s0)
                    /\(app lb (cons b (cons a la)))=l0))))
     (H0,(updateR R r0 (29)))).
Clear H1; Intro.
Inversion_clear H1.
Inversion_clear H2.
SplitAllHyps.
Exists x; Exists x0.
Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R.
Clear H1; Intros.
SplitAllExs.
Exists x; Exists x0.
Apply MBlk_RF_Insensitive with R; Auto.
Clear H1; Intros.
SplitAllExs.
Inversion_clear H1.
Exists x; Exists x0; Exists x1; Exists x2; Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Clear H2; Intro; Apply RF_Insensitive_Distrib_Star.
Intro; Apply RF_Insensitive_Distrib_Star.
Intro; Apply Pair_RF_Insensitive.
Intro; Apply Slist_RF_Insensitive.
Intro; Apply Slist_RF_Insensitive.
Intro; Apply Pair_RF_Insensitive.
Cut (EX la:(list nat) |
     (EX lb:(list nat) |
       (EX b:nat |
	 (star (Pair (lookupR R r20) (lookupR R r27) (lookupR R r25))
           (star
             (star
               (star
                 (Pair (lookupR R r3) (lookupR R r27)
                   (lookupR R r25))
                 (Slist la (lookupR R r25) (0)))
               (Slist lb (lookupR R r26) (lookupR R r28)))
             (Pair (lookupR R r28) b (lookupR R r3))) (H0,R))
              /\(app lb (cons b (cons (lookupR R r27) la)))=l0))).
Clear H1; Intro.
SplitAllExs.
Inversion_clear H2.
Cut (star (Pair (lookupR R r3) (lookupR R r27) (lookupR R r25))
     (star
       (star
         (star
	   (Pair (lookupR R r20) (lookupR R r27) (lookupR R r25))
               (Slist x (lookupR R r25) (0)))
             (Slist x0 (lookupR R r26) (lookupR R r28)))
           (Pair (lookupR R r28) x1 (lookupR R r3))) (H0,R)).
Clear H1; Intro.
Apply star_subst with (Pair (lookupR R r3) (lookupR R r27) (lookupR R r25))
         (star
           (star
             (star
               (Pair (lookupR R r20) (lookupR R r27) (lookupR R r25))
               (Slist x (lookupR R r25) (0)))
             (Slist x0 (lookupR R r26) (lookupR R r28)))
           (Pair (lookupR R r28) x1 (lookupR R r3))); Auto.
Intro; Apply Pair_MBlk.
Clear H1; Intros.
Exists (lookupR R r27); Exists x; Exists x0; Exists x1; Constructor; Auto.
Apply star_assoc_L.
Apply star_subst with
	 (star (Pair (lookupR R r20) (lookupR R r27) (lookupR R r25))
	   (star
             (star
	       (Pair (lookupR R r3) (lookupR R r27) (lookupR R r25))
               (Slist x (lookupR R r25) (0)))
             (Slist x0 (lookupR R r26) (lookupR R r28))))
	 (Pair (lookupR R r28) x1 (lookupR R r3)); Auto.
Apply star_assoc_R; Auto.
Clear H1; Intros.
Apply star_assoc_L.
Apply star_subst with
(star (Pair (lookupR R r20) (lookupR R r27) (lookupR R r25))
       (star (Pair (lookupR R r3) (lookupR R r27) (lookupR R r25))
         (Slist x (lookupR R r25) (0))))
     (Slist x0 (lookupR R r26) (lookupR R r28)); Auto.
Apply star_assoc_R; Auto.
Clear H1; Intros.
Apply star_assoc_L.
Apply star_subst with
(star (Pair (lookupR R r20) (lookupR R r27) (lookupR R r25))
(Pair (lookupR R r3) (lookupR R r27) (lookupR R r25)))
(Slist x (lookupR R r25) (0)); Auto.
Apply star_assoc_R; Auto.
Intro; Apply star_sym.
Inversion_clear H1.
Inversion_clear H2.
SplitAllHyps.
SplitAllExs.
Inversion_clear H4.
Exists x1; Exists x2; Exists x3; Constructor; Auto.
Exists x; Exists x0; Constructor; Auto.
Apply star_subst with (Pair (lookupR R r20) (lookupR R r27) (lookupR R r25))
         [s0:(heap*rfile)]
          ((lookupR R r28)=(0)
           ->(EX l:(list nat) |
                (star
                  (Pair (lookupR R r3) (lookupR R r27) (lookupR R r25))
                  (Slist l (lookupR R r25) (0)) s0)
                /\(cons (lookupR R r27) l)=l0)/\(lookupR R r26)=(0))
          /\(~(lookupR R r28)=(0)
             ->(EX la:(list nat) |
                  (EX lb:(list nat) |
                     (EX b:nat |
                        (star
                          (star
                            (star
                              (Pair (lookupR R r3) (lookupR R r27)
                                (lookupR R r25))
                              (Slist la (lookupR R r25) (0)))
                            (Slist lb (lookupR R r26) (lookupR R r28)))
                          (Pair (lookupR R r28) b (lookupR R r3)) s0)
                        /\(app lb (cons b (cons (lookupR R r27) la)))
                           =l0)))); Auto.
Clear H1; Intros.
Inversion_clear H1; Auto.
Inversion_clear H1.
Unfold getValinR in H2.
Exists x; Auto.
Clear H0; Unfold updateR; Unfold getValinR.
Unfold lookupR; Fold lookupR; Unfold beq_reg.
Intro; Apply Good_RF_Insensitive.
Apply star_assoc_R.
Apply star_sym; Auto.
Unfold updateR; Unfold getValinR.
Unfold lookupR; Fold lookupR; Unfold beq_reg; Trivial.
(* jd free *)
Apply I_jd with (TT_free l0).
CTLookupTac.
Intros; Left.
Unfold T_free; Unfold Pred_free.
Inversion_clear H.
Constructor; Auto.
Cut (EX lnk:nat |
      (EX siz:nat |
         (star
           (star
             [s0:(heap*rfile)]
              ((getValinR s0 r28)=(0)
               ->(EX b:nat |
                    (EX l:(list nat) |
                       (star
                         (Pair (getValinR s0 r20) b (getValinR s0 r25))
                         (Slist l (getValinR s0 r25) (0)) s0)
                       /\(cons b l)=l0))/\(getValinR s0 r26)=(0))
              /\(~(getValinR s0 r28)=(0)
                 ->(EX a:nat |
                      (EX la:(list nat) |
                         (EX lb:(list nat) |
                            (EX b:nat |
                               (star
                                 (star
                                   (star
                                     (Pair (getValinR s0 r20) a
                                       (getValinR s0 r25))
                                     (Slist la (getValinR s0 r25) (0)))
                                   (Slist lb (getValinR s0 r26)
                                     (getValinR s0 r28)))
                                 (Pair (getValinR s0 r28) b
                                   (getValinR s0 r3)) s0)
                               /\(app lb (cons b (cons a la)))=l0)))))
		     (Good (getValinR s r2)))
		   (MBlk (getValinR s r3) lnk siz) s))).
Clear H0; Intro.
SplitAllExs.
Exists x; Exists x0.
Apply star_assoc_R.
Apply star_subst with [s0:(heap*rfile)]
      ((getValinR s0 r28)=(0)
       ->(EX b:nat |
            (EX l:(list nat) |
               (star (Pair (getValinR s0 r20) b (getValinR s0 r25))
                 (Slist l (getValinR s0 r25) (0)) s0)/\(cons b l)=l0))
         /\(getValinR s0 r26)=(0))
      /\(~(getValinR s0 r28)=(0)
         ->(EX a:nat |
              (EX la:(list nat) |
                 (EX lb:(list nat) |
                    (EX b:nat |
                       (star
                         (star
                           (star
                             (Pair (getValinR s0 r20) a
                               (getValinR s0 r25))
                             (Slist la (getValinR s0 r25) (0)))
                           (Slist lb (getValinR s0 r26)
                             (getValinR s0 r28)))
                         (Pair (getValinR s0 r28) b (getValinR s0 r3))
                         s0)/\(app lb (cons b (cons a la)))=l0)))))
     (star (Good (getValinR s r2)) (MBlk (getValinR s r3) x x0)); Auto.
Apply star_assoc_L; Auto.
Intro; Apply star_sym.
Induction s; Inversion_clear H0.
Inversion_clear H.
SplitAllHyps.
SplitAllExs.
Exists x1; Exists x2.
Exists x; Exists x0; Constructor; Auto.
Save.

Lemma WF_next2 : (l0:(list int))
 (Infer (CT_Copy l0) (T_next2 l0) C_next2).
Proof.
Intro; Unfold C_next2.
(* bgti cprev nil lnkprv *)
Apply I_bgti with [s:state] (star
   ([s0:state](EX b:nat |
               (EX l:(list nat) |
                  (star (Pair (getValinR s0 r20) b (getValinR s0 r25))
                    (Slist l (getValinR s0 r25) (0)) s0)/\(cons b l)=l0))
		     /\(getValinR s0 r26)=(0)
		     /\(getValinR s0 cprev)=O)
   (Good (getValinR s flist)) s)
 (T_lnkprv l0).
CTLookupTac.
Intros.
Unfold T_next2 in H1.
Apply star_subst_sameR with [s:(heap*rfile)]
          ((getValinR s r28)=(0)
           ->(EX b:nat |
                (EX l:(list nat) |
                   (star (Pair (getValinR s r20) b (getValinR s r25))
                     (Slist l (getValinR s r25) (0)) s)/\(cons b l)=l0))
             /\(getValinR s r26)=(0))
          /\(~(getValinR s r28)=(0)
             ->(EX a:nat |
                  (EX la:(list nat) |
                     (EX lb:(list nat) |
                        (EX b:nat |
                           (star
                             (star
                               (star
                                 (Pair (getValinR s r20) a
                                   (getValinR s r25))
                                 (Slist la (getValinR s r25) (0)))
                               (Slist lb (getValinR s r26)
                                 (getValinR s r28)))
                             (Pair (getValinR s r28) b (getValinR s r3))
                             s)/\(app lb (cons b (cons a la)))=l0)))))
         (Good (getValinR (H,R) r2)); Auto.
Clear H1; Intros.
Inversion_clear H2.
Clear H4; Unfold getValinR in H3.
Cut (lookupR R r28)=O.
Intro; Cut (EX b:nat |
            (EX l:(list nat) |
               (star (Pair (lookupR R r20) b (lookupR R r25))
                 (Slist l (lookupR R r25) (0)) (H1,R))/\(cons b l)=l0))
         /\(lookupR R r26)=(0); Auto.
Clear H3; Intro.
Inversion_clear H3; Constructor; Auto.
Auto with arith.
Unfold T_next2; Unfold T_lnkprv; Intros.
Apply star_subst_sameR with [s:(heap*rfile)]
          ((getValinR s r28)=(0)
           ->(EX b:nat |
                (EX l:(list nat) |
                   (star (Pair (getValinR s r20) b (getValinR s r25))
                     (Slist l (getValinR s r25) (0)) s)/\(cons b l)=l0))
             /\(getValinR s r26)=(0))
          /\(~(getValinR s r28)=(0)
             ->(EX a:nat |
                  (EX la:(list nat) |
                     (EX lb:(list nat) |
                        (EX b:nat |
                           (star
                             (star
                               (star
                                 (Pair (getValinR s r20) a
                                   (getValinR s r25))
                                 (Slist la (getValinR s r25) (0)))
                               (Slist lb (getValinR s r26)
                                 (getValinR s r28)))
                             (Pair (getValinR s r28) b (getValinR s r3))
                             s)/\(app lb (cons b (cons a la)))=l0)))))
         (Good (getValinR (H,R) r2)); Auto.
Clear H1; Intros.
SplitAllHyps.
Clear H3; Unfold getValinR in H4; Unfold getValinR; Cut ~(lookupR R r28)=O.
Intro; Constructor; Auto.
Intro EQO; Rewrite EQO in H0; Inversion H0.
(* mov tgt mptr *)
Apply I_mov with [s:(heap*rfile)]
      (star
        [s0:(heap*rfile)]
         (EX b:nat |
            (EX l:(list nat) |
               (star (Pair (getValinR s0 tgt) b (getValinR s0 r25))
                 (Slist l (getValinR s0 r25) (0)) s0)/\(cons b l)=l0))
        (Good (getValinR s r2)) s).
Intros.
Apply star_subst_diffR with R
[s0:(heap*rfile)]
          (EX b:nat |
             (EX l:(list nat) |
                (star (Pair (getValinR s0 r20) b (getValinR s0 r25))
                  (Slist l (getValinR s0 r25) (0)) s0)/\(cons b l)=l0))
          /\(getValinR s0 r26)=(0)/\(getValinR s0 r28)=(0)
         (Good (getValinR (H,R) r2)); Auto.
Clear H0; Unfold getValinR; Intros.
SplitAllHyps.
SplitAllExs.
Unfold updateR; Unfold lookupR; Fold lookupR; Unfold beq_reg.
Inversion_clear H2; Exists x; Exists x0; Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply Pair_RF_Insensitive.
Intro; Apply Slist_RF_Insensitive.
Intro; Apply Good_RF_Insensitive.
(* mov cprev tgt *)
Apply I_mov with [s:(heap*rfile)]
      (star
        [s0:(heap*rfile)]
         (EX b:nat |
            (EX l:(list nat) |
               (star (Pair (getValinR s0 cprev) b (getValinR s0 r25))
                 (Slist l (getValinR s0 r25) (0)) s0)/\(cons b l)=l0))
		  /\(getValinR s0 cprev)=(getValinR s0 tgt)
        (Good (getValinR s r2)) s)/\~(getValinR s cprev)=O.
Intros; Unfold updateR.
Constructor.
Apply star_subst_diffR with R
[s0:(heap*rfile)]
          (EX b:nat |
             (EX l:(list nat) |
                (star (Pair (getValinR s0 r26) b (getValinR s0 r25))
                  (Slist l (getValinR s0 r25) (0)) s0)/\(cons b l)=l0))
         (Good (getValinR (H,R) r2)); Auto.
Clear H0; Unfold getValinR; Intros.
Unfold lookupR; Fold lookupR; Unfold beq_reg.
Constructor; Auto.
SplitAllExs.
Inversion_clear H1.
Exists x; Exists x0; Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply Pair_RF_Insensitive.
Intro; Apply Slist_RF_Insensitive.
Intro; Apply Good_RF_Insensitive.
Unfold getValinR; Unfold lookupR; Fold lookupR; Unfold beq_reg.
Inversion_clear H0.
Inversion_clear H1.
SplitAllHyps.
SplitAllExs.
Inversion_clear H2.
Apply Star_Pair_ptr_gt_O with (x,R) (getValinR (x,R) r25) x1
	 (Slist x2 (getValinR (x,R) r25) (0)); Auto.
(* jd test *)
Apply I_jd with (T_test l0).
CTLookupTac.
Intros; Unfold T_test.
Inversion_clear H.
Induction s.
Apply star_subst_sameR with [s0:(heap*rfile)]
          (EX b:nat |
             (EX l:(list nat) |
                (star (Pair (getValinR s0 r28) b (getValinR s0 r25))
                  (Slist l (getValinR s0 r25) (0)) s0)/\(cons b l)=l0))
          /\(getValinR s0 r28)=(getValinR s0 r26)
         (Good (getValinR (a,b) r2)); Auto.
Clear H0; Unfold getValinR; Intros.
Unfold getValinR in H1; Constructor.
Intro; Absurd (lookupR b r28)=(0); Auto.
Intro.
Inversion_clear H.
SplitAllExs.
Inversion_clear H3.
Exists x0; Exists (nil nat); Exists x.
Constructor; Auto.
Apply star_sym.
Apply star_subst with (Pair (lookupR b r28) x (lookupR b r25))
        (Slist x0 (lookupR b r25) (0)); Auto.
Clear H; Intros; Rewrite H4.
Apply star_subst with
(Slist x0 (lookupR b r25) (0)) emp; Auto.
Apply star_sym; Apply star_emp_rev; Auto.
Clear H; Intros; Apply l_nil; Auto.
Save.

Lemma WF_lnkprv : (l0:(list int))
 (Infer (CT_Copy l0) (T_lnkprv l0) C_lnkprv).
Proof.
Intro; Unfold C_lnkprv; Unfold T_lnkprv.
(* st cprev(1) mptr *)
Apply I_st with [s:(heap*rfile)]
      (star
        [s0:(heap*rfile)]
         ~(getValinR s0 r28)=(0)
         /\(EX a:nat |
              (EX la:(list nat) |
                 (EX lb:(list nat) |
                    (EX b:nat |
                       (star
                         (star
                           (star
                             (Pair (getValinR s0 r20) a
                               (getValinR s0 r25))
                             (Slist la (getValinR s0 r25) (0)))
                           (Slist lb (getValinR s0 r26)
                             (getValinR s0 r28)))
                         (Pair (getValinR s0 r28) b (getValinR s0 mptr))
                         s0)/\(app lb (cons b (cons a la)))=l0))))
        (Good (getValinR s r2)) s).
Intros.
Cut (hindom (plus (1) (lookupR R r28)) H).
Intro; Constructor; Auto.
Apply Write_Star with[s:(heap*rfile)]
          ~(getValinR s r28)=(0)
          /\(EX a:nat |
               (EX la:(list nat) |
                  (EX lb:(list nat) |
                     (EX b:nat |
                        (star
                          (star
                            (star
                              (Pair (getValinR s r20) a
                                (getValinR s r25))
                              (Slist la (getValinR s r25) (0)))
                            (Slist lb (getValinR s r26)
                              (getValinR s r28)))
                          (Pair (getValinR s r28) b (getValinR s r3)) s)
                        /\(app lb (cons b (cons a la)))=l0)))); Auto.
Clear H0; Intros.
Inversion_clear H0.
SplitAllExs.
Unfold getValinR in H3; Inversion_clear H3.
Cut (star (Pair (lookupR R r28) x2 (lookupR R r3))
         (star
           (star (Pair (lookupR R r20) x (lookupR R r25))
             (Slist x0 (lookupR R r25) (0)))
           (Slist x1 (lookupR R r26) (lookupR R r28))) (H',R)).
Clear H0; Intro.
Apply indom_star with R
       (Pair (lookupR R r28) x2 (lookupR R r3))
     (star
       (star (Pair (lookupR R r20) x (lookupR R r25))
         (Slist x0 (lookupR R r25) (0)))
       (Slist x1 (lookupR R r26) (lookupR R r28))); Auto.
Clear H0; Intros.
Inversion_clear H0.
Inversion_clear H3.
SplitAllHyps.
Unfold plus; Apply MBlk_indom_1 with R x3 x4; Auto.
Auto with arith.
Apply star_sym; Auto.
Unfold getValinR; Clear H0; Intros.
Inversion_clear H0; Constructor; Auto.
SplitAllExs.
Exists x; Exists x0; Exists x1; Exists x2.
Inversion_clear H3; Constructor; Auto.
Apply star_sym.
Apply Write_Star with (Pair (lookupR R r28) x2 (lookupR R r3)).
Apply star_sym; Auto.
Clear H0; Intros.
Inversion_clear H0.
Inversion_clear H3.
SplitAllHyps.
Unfold plus; Apply MBlk_indom_1 with R x3 x4; Auto with arith.
Intro; Apply Write_Pair_lnk.
Apply indom_star with R 
[s:(heap*rfile)]
          ~(getValinR s r28)=(0)
          /\(EX a:nat |
               (EX la:(list nat) |
                  (EX lb:(list nat) |
                     (EX b:nat |
                        (star
                          (star
                            (star
                              (Pair (getValinR s r20) a
                                (getValinR s r25))
                              (Slist la (getValinR s r25) (0)))
                            (Slist lb (getValinR s r26)
                              (getValinR s r28)))
                          (Pair (getValinR s r28) b (getValinR s r3)) s)
                        /\(app lb (cons b (cons a la)))=l0))))
         (Good (getValinR (H,R) r2)); Auto.
Clear H0; Intros.
Inversion_clear H0.
SplitAllExs.
Inversion_clear H2.
Unfold getValinR in H0.
Apply indom_star with R
(Pair (lookupR R r28) x2 (lookupR R r3))
(star (star (Pair (lookupR R r20) x (lookupR R r25))
             (Slist x0 (lookupR R r25) (0)))
           (Slist x1 (lookupR R r26) (lookupR R r28))).
Apply star_sym; Auto.
Clear H0; Intros.
Inversion_clear H0.
Inversion_clear H2.
SplitAllHyps.
Unfold plus; Apply MBlk_indom_1 with R x3 x4; Auto with arith.
(* mov cprev mptr *)
Apply I_mov with [s:(heap*rfile)]
      (star
        [s0:(heap*rfile)]
         ~(getValinR s0 r28)=(0)
         /\(EX a:nat |
              (EX la:(list nat) |
                 (EX lb:(list nat) |
                   (star
                     (star
                       (Slist la (getValinR s0 src) (0))
                       (Slist lb (getValinR s0 tgt) (getValinR s0 cprev)))
                     (Pair (getValinR s0 cprev) a (getValinR s0 src))
                      s0)/\(app lb (cons a la))=l0)))
             (Good (getValinR s r2)) s).
Intros.
Apply star_subst_diffR with R
[s0:(heap*rfile)]
          ~(getValinR s0 r28)=(0)
          /\(EX a:nat |
               (EX la:(list nat) |
                  (EX lb:(list nat) |
                     (EX b:nat |
                        (star
                          (star
                            (star
                              (Pair (getValinR s0 r20) a
                                (getValinR s0 r25))
                              (Slist la (getValinR s0 r25) (0)))
                            (Slist lb (getValinR s0 r26)
                              (getValinR s0 r28)))
                          (Pair (getValinR s0 r28) b (getValinR s0 r20))
                          s0)/\(app lb (cons b (cons a la)))=l0))))
         (Good (getValinR (H,R) r2)); Auto.
Clear H0; Unfold getValinR; Intros.
Unfold updateR; Unfold lookupR; Fold lookupR; Unfold beq_reg.
Inversion_clear H1.
SplitAllExs.
Inversion_clear H3.
Cut (star (Pair (lookupR R r20) x (lookupR R r25))
	   (star (Slist x0 (lookupR R r25) (0))
	     (star (Slist x1 (lookupR R r26) (lookupR R r28))
	       (Pair (lookupR R r28) x2 (lookupR R r20)))) (H0,R)).
Clear H1; Intro.
Constructor.
Apply Star_Pair_ptr_gt_O with (H0,R) (lookupR R r25) x
(star (Slist x0 (lookupR R r25) (0))
           (star (Slist x1 (lookupR R r26) (lookupR R r28))
             (Pair (lookupR R r28) x2 (lookupR R r20)))); Auto.
Exists x; Exists x0; Exists (app x1 (cons x2 (nil nat))).
Constructor.
Apply star_sym.
Apply star_subst_diffR with R
(Pair (lookupR R r20) x (lookupR R r25))
         (star (Slist x0 (lookupR R r25) (0))
           (star (Slist x1 (lookupR R r26) (lookupR R r28))
             (Pair (lookupR R r28) x2 (lookupR R r20)))); Auto.
Intro; Apply Pair_RF_Insensitive.
Clear H1; Intros.
Apply star_subst_diffR with R
(Slist x0 (lookupR R r25) (0))
         (star (Slist x1 (lookupR R r26) (lookupR R r28))
           (Pair (lookupR R r28) x2 (lookupR R r20))); Auto.
Intro; Apply Slist_RF_Insensitive.
Clear H3; Intros.
Apply Slist_RF_Insensitive with R.
Apply Compose_Slist_Pair_to_Slist with (lookupR R r28); Auto.
Rewrite <- H4; Apply list_prop_1.
Apply star_assoc_L.
Apply star_assoc_L.
Assumption.
Intro; Apply Good_RF_Insensitive.
(* jd test *)
Apply I_jd with (T_test l0).
CTLookupTac.
Unfold T_test; Intros.
Apply star_subst with 
[s0:(heap*rfile)]
         ~(getValinR s0 r28)=(0)
         /\(EX a:nat |
              (EX la:(list nat) |
                 (EX lb:(list nat) |
                    (star
                      (star (Slist la (getValinR s0 r25) (0))
                        (Slist lb (getValinR s0 r26) (getValinR s0 r28)))
                      (Pair (getValinR s0 r28) a (getValinR s0 r25)) s0)
                    /\(app lb (cons a la))=l0)))
        (Good (getValinR s r2)); Auto.
Clear H; Intros.
Inversion_clear H.
Constructor; Intro.
Absurd (getValinR s0 r28)=(0); Assumption.
SplitAllExs.
Exists x0; Exists x1; Exists x; Assumption.
Save.

Lemma WF_halt : (l0:(list int))
 (Infer (CT_Copy l0) (T_halt l0) C_halt).
Proof.
Intro; Unfold C_halt.
Apply I_jd with (T_halt l0); Auto.
CTLookupTac.
Save.
