(* Proofs - free *)
Require Arith.
Require cdsa.
Require property.

(* Postcondition - free; precondition is already defined as part of T_free *)
Definition Q_free[P:assert] : assert :=
 [s:state]
 (star P (
  Good (getValinR s flist)
   ) s).

Theorem WF_free : (Pred:assert; ct:codeheapty; f:lab; A_iter:assert)
 ((s:state)(Q_free Pred s) ->
   (exT assert ([A:assert](lookupCT ct f A) /\ (A s))))
  -> ((H:heap;R,R':rfile)(Pred (H,R)) -> (Pred (H,R')))
  -> ((lookupCT ct L_iter A_iter)
  /\ ((s:state) (T_iter Pred f s) -> (A_iter s)))
  -> (Infer ct (T_free Pred f) C_free).
Proof.
Intros.
Unfold C_free.
(* subi hp, fptr, 2 *)
Apply I_subi with
 (Aand
   (T_free Pred f)
   ([s:state](getValinR s hp) = (minus (getValinR s fptr) (2)))
 ).
Unfold T_free.
Unfold Aand.
Unfold updateR; Unfold getValinR; Fold getValinR.
Unfold lookupR; Fold lookupR; Unfold beq_reg.
Intros.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H3.
Constructor; Auto; Constructor; Auto.
Exists x; Exists x0.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intros; Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply H0.
Intros; Apply MBlk_RF_Insensitive with R; Assumption.
Intros; Apply Good_RF_Insensitive with R; Assumption.
(* movi prev nil *)
Apply I_movi with
 (Aand
   (Aand (T_free Pred f)
     [s0:(heap*rfile)](getValinR s0 r4)=(minus (getValinR s0 r3) (2)))
   ([s:state](getValinR s prev)=pnil)).
Unfold T_free; Unfold Aand.
Unfold updateR; Unfold getValinR; Fold getValinR.
Unfold lookupR; Fold lookupR; Unfold beq_reg.
Intros; Constructor; Auto.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H3.
Inversion_clear H4.
Constructor; Auto.
Constructor; Auto.
Exists x; Exists x0.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intros; Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply H0.
Intros; Apply MBlk_RF_Insensitive with R; Auto.
Intros; Apply Good_RF_Insensitive with R; Assumption.
(* mov p flist *)
Apply I_mov with
 [s:state]
 ((EX lnk:addr | (EX siz:addr |
       (star
	 (star Pred
	   (MBlk (plus (2) (getValinR s hp)) lnk siz))
	 (MidL (getValinR s flist) (getValinR s prev) (getValinR s p))
	  s)))
	  /\ ((getValinR s ret0)=f))
	  /\ ((getValinR s prev)=pnil).
Unfold T_free; Unfold Aand.
Unfold updateR; Unfold getValinR; Fold getValinR.
Unfold lookupR; Fold lookupR; Unfold beq_reg.
Intros.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H3.
Constructor; Auto.
Constructor; Auto.
Exists x; Exists x0.
Apply RF_Insensitive_Distrib_Star with R.
Intros; Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply H0.
Intros; Apply MBlk_RF_Insensitive with R; Auto.
Intros; Apply MidL_RF_Insensitive with R; Auto.
Inversion_clear H4.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H8.
Inversion_clear H9.
Replace (plus (2) (lookupR R r4)) with (lookupR R r3).
Rewrite H5.
Unfold star.
Exists x1; Exists x2.
Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Clear H3; Clear H4; Clear H8.
Inversion_clear H10; Unfold MidL.
Exists x3; Unfold star.
Exists hempty; Exists x2.
Constructor.
Apply disj_emp.
Constructor.
Apply append_emp.
Constructor; Auto.
Unfold EndL; Constructor.
Intro; Apply mbl_O.
Unfold emp; Unfold getValinH; Unfold hread; Unfold hempty; Auto.
Intro; Absurd O=O; Auto.
Rewrite H6.
Apply le_plus_minus.
Apply gt_S_le.
Apply gt_trans with (lookupR R r3); Auto with arith.
Apply Star_MBlk_ptr_gt_2 with (x1,R) x x0 Pred.
Apply star_sym; Auto.
(* jd iter *)
Inversion_clear H1.
Apply I_jd with A_iter; Auto.
Intros; Apply H3.
Unfold T_iter.
Inversion_clear H1.
Constructor; Auto.
Save.

Theorem WF_iter : (Pred:assert; ct:codeheapty; f:lab; A_next,A_trylo:assert)
 ((s:state)(Q_free Pred s) ->
   (exT assert ([A:assert](lookupCT ct f A) /\ (A s))))
  -> ((H:heap;R,R':rfile)(Pred (H,R)) -> (Pred (H,R')))
  -> ((lookupCT ct L_next A_next)
  /\ ((s:state)(T_next Pred f s) -> (A_next s)))
  -> ((lookupCT ct L_trylo A_trylo)
  /\ ((s:state)(T_trylo Pred f s) -> (A_trylo s)))
  -> (Infer ct (T_iter Pred f) C_iter).
Proof.
Intros; Unfold C_iter.
(* bgti p nil next *)
Apply I_bgti with
 (Aand (T_iter Pred f) ([s:state](getValinR s p)=pnil))
 A_next.
Inversion_clear H1; Auto.
Unfold T_iter; Unfold Aand; Intros.
Constructor; Auto.
Unfold getValinR.
Apply sym_eq; Auto with arith.
Unfold T_iter; Unfold T_next; Intros.
Inversion_clear H1.
Apply H7.
Constructor; Auto.
Clear H5; Unfold getValinR; Intro.
Rewrite H1 in H4; Inversion H4.
(* st hp(link) p *)
Apply I_st with
 [s:state]
 (((EX siz:addr |
	 (star
	   (star Pred
	     (MBlk (plus (2) (getValinR s hp)) pnil siz))
	   (MidL (getValinR s flist) (getValinR s prev) pnil)
	    s))
	    /\ ((getValinR s ret0) = f))
	    /\ ((lt (getValinR s prev) (getValinR s hp))
	    \/ ((getValinR s prev)=pnil))).
Unfold T_iter; Unfold Aand; Unfold getValinR.
Intros.
SplitAllHyps.
SplitAllExs.
Cut (star (MBlk (plus (2) (lookupR R r4)) x x0)
     (star Pred (MidL (lookupR R r2) (lookupR R r5) (lookupR R r6))) (H3,R)).
Clear H5; Intro H5.
Constructor.
Apply Star_MBlk_indom with R x x0
   (star Pred (MidL (lookupR R r2) (lookupR R r5) (lookupR R r6))); Auto.
Apply lt_trans with (2); Auto.
Apply gt_lt.
Apply Star_MBlk_siz_gt_2 with (H3,R) (plus (2) (lookupR R r4)) x
   (star Pred (MidL (lookupR R r2) (lookupR R r5) (lookupR R r6))); Auto.
Constructor; Auto.
Constructor; Auto.
Exists x0.
Unfold plus; Rewrite H6.
Cut (star (MBlk (plus (2) (lookupR R r4)) (0) x0)
     (star Pred (MidL (lookupR R r2) (lookupR R r5) (0)))
     ((hwrite H3 (lookupR R r4) O),R)).
Clear H5; Intro H5.
Apply star_subst with (star (MBlk (plus (2) (lookupR R r4)) (0) x0) Pred)
   (MidL (lookupR R r2) (lookupR R r5) (0)); Auto.
Apply star_assoc_R; Auto.
Intro; Apply star_sym.
Rewrite H6 in H5; Apply Write_Star_MBlk_lnk with x; Auto.
Apply star_assoc_L.
Apply star_subst with (star Pred (MBlk (plus (2) (lookupR R r4)) x x0))
     (MidL (lookupR R r2) (lookupR R r5) (lookupR R r6)); Auto.
Intro; Apply star_sym.
(* jd trylo *)
Inversion_clear H2.
Apply I_jd with A_trylo; Auto.
Intros; Apply H4.
Unfold T_trylo.
SplitAllHyps.
Inversion_clear H2.
Exists pnil; Exists O.
Constructor; Auto.
Constructor; Auto.
Apply star_assoc_R.
Apply star_subst with Pred
     (star (MBlk (plus (2) (getValinR s r4)) (0) x)
       (MidL (getValinR s r2) (getValinR s r5) (0))); Auto.
Apply star_assoc_L; Auto.
Clear H1; Intros.
Apply star_sym.
Apply star_subst with (MBlk (plus (2) (getValinR s r4)) (0) x)
     (MidL (getValinR s r2) (getValinR s r5) (0)); Auto.
Clear H1; Intros.
Apply Compose_MBlk_MBlkLst_to_MBlkLst with pnil x; Auto.
Apply star_sym.
Apply star_subst with emp (MBlk (plus (2) (getValinR s r4)) (0) x); Auto.
Apply emp_star; Auto.
Intro; Apply mbl_O.
Clear H1; Intro; Apply MidL_pnil_EndL.
Save.

Theorem WF_next : (Pred:assert; ct:codeheapty; f:lab; A_tryhi,A_iter:assert)
 ((s:state)(Q_free Pred s) ->
   (exT assert ([A:assert](lookupCT ct f A) /\ (A s))))
  -> ((H:heap;R,R':rfile)(Pred (H,R)) -> (Pred (H,R')))
  -> ((lookupCT ct L_tryhi A_tryhi)
  /\ ((s:state)(T_tryhi Pred f s) -> (A_tryhi s)))
  -> ((lookupCT ct L_iter A_iter)
  /\ ((s:state)(T_iter Pred f s) -> (A_iter s)))
  -> (Infer ct (T_next Pred f) C_next).
Proof.
Intros; Unfold C_next.
(* bgt p hp tryhi *)
Unfold T_next.
Apply I_bgt with 
 [s:(heap*rfile)]
 (((EX lnk:nat |
       (EX siz:nat |
         (star
           (star Pred (MBlk (plus (2) (getValinR s r4)) lnk siz))
           (MidL (getValinR s r2) (getValinR s r5)
             (getValinR s r6)) s)))/\(getValinR s r0)=f)
	      /\(lt (getValinR s p) (getValinR s hp)))
	      /\~(getValinR s r6)=(0)
 A_tryhi.
Inversion_clear H1; Auto.
Intros.
Inversion_clear H5; Constructor; Auto.
Inversion_clear H6; Constructor; Auto.
Unfold getValinR;
Cut (lt (lookupR R r6) (lookupR R r4)) \/ ((lookupR R r6) = (lookupR R r4));
Inversion_clear H5.
Intro OR; Inversion_clear OR; Auto.
Inversion_clear H6.
Inversion_clear H10.
Cut (star Pred (star (MBlk (plus (2) (getValinR (H3,R) r4)) x x0)
         (MidL (getValinR (H3,R) r2) (getValinR (H3,R) r5)
           (getValinR (H3,R) r6))) (H3,R)).
Clear H6; Intro.
Inversion_clear H6.
Inversion_clear H10.
Inversion_clear H6.
Inversion_clear H11.
Inversion_clear H12.
Inversion_clear H13.
Inversion_clear H12.
Inversion_clear H13.
Inversion_clear H14.
Inversion_clear H15.
Absurd (lookupR R r6)=(lookupR R r4); Auto.
Apply disj_indom_neq with x4 x3.
Apply disj_sym; Assumption.
Apply MidL_indom_Q with R (getValinR (H3,R) r2) (getValinR (H3,R) r5); Auto.
Replace (lookupR R r4) with (plus O (lookupR R r4)); Auto.
Apply MBlk_indom with R x x0; Auto.
Apply lt_trans with (2); Auto.
Apply gt_lt.
Apply MBlk_siz_gt_2 with (x3,R) (plus (2) (getValinR (H3,R) r4)) x; Auto.
Apply star_assoc_L; Auto.
Apply le_lt_or_eq; Auto.
Intros; Inversion_clear H1.
Apply H7.
Unfold T_tryhi; Intros.
Constructor; Auto.
(*mov prev p *)
Apply I_mov with 
 [s:(heap*rfile)]
 (EX oldprev:addr |
   (((EX lnk:nat |
         (EX siz:nat |
	   (star
	     (star Pred (MBlk (plus (2) (getValinR s r4)) lnk siz))
	     (MidL (getValinR s r2) oldprev
               (getValinR s r6))
		s)))
		/\(getValinR s r0)=f)
		/\(lt (getValinR s r6) (getValinR s r4)))
		/\~(getValinR s r6)=(0))
		/\((getValinR s prev)=(getValinR s p)).
Unfold updateR; Unfold getValinR.
Unfold lookupR; Fold lookupR; Unfold beq_reg.
Intros; Constructor; Auto.
Exists (lookupR R r5).
Inversion_clear H4; Constructor; Auto.
Inversion_clear H5; Constructor; Auto.
Inversion_clear H4; Constructor; Auto.
Inversion_clear H5.
Inversion_clear H4.
Exists x; Exists x0.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intros; Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply H0.
Intro; Apply MBlk_RF_Insensitive.
Intro; Apply MidL_RF_Insensitive.
(* ld p p(link) *)
Apply I_ld with
  [s:(heap*rfile)]
  ((EX lnk:nat |
      (EX siz:nat |
        (star
          (star Pred
            (MBlk (plus (2) (getValinR s hp)) lnk siz))
          (MidL (getValinR s flist) (getValinR s prev) (getValinR s p))
	   s)))
           /\(getValinR s ret0)=f)
           /\(lt (getValinR s prev) (getValinR s hp)).
Unfold updateR; Unfold getValinR.
Unfold lookupR; Fold lookupR; Unfold beq_reg.
Intros.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Cut (EX p':addr | 
    ((getValinH (H3,R) (lookupR R p))=(hvsome p')) /\
    (star (MidL (lookupR R flist) (lookupR R p) p')
      (star Pred (MBlk (plus (2) (lookupR R r4)) x0 x1)) (H3,R))).
Clear H5; Intro.
Inversion_clear H4.
Exists x2.
Unfold plus; Unfold getValinH in H5.
Inversion_clear H5; Constructor; Auto.
Constructor.
Constructor; Auto.
Exists x0; Exists x1.
Unfold plus in H10.
Apply star_sym.
Rewrite H6.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply MidL_RF_Insensitive.
Intros; Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply H0.
Intro; Apply MBlk_RF_Insensitive.
Rewrite H6; Auto.
Cut (star (MidL (lookupR R r2) x (lookupR R r6))
    (star Pred (MBlk (plus (2) (lookupR R r4)) x0 x1)) (H3,R)).
Clear H5; Intro.
Apply Star_MidL_next with x; Auto.
Apply star_sym; Auto.
(* jd iter *)
Inversion_clear H2.
Apply I_jd with A_iter; Auto.
Intros; Apply H4.
Unfold T_iter; Intros.
Inversion_clear H2; Constructor; Auto.
Save.

Theorem WF_tryhi : (Pred:assert; ct:codeheapty; f:lab; A_notjhi,A_trylo:assert)
 ((s:state)(Q_free Pred s) ->
   (exT assert ([A:assert](lookupCT ct f A) /\ (A s))))
  -> ((H:heap;R,R':rfile)(Pred (H,R)) -> (Pred (H,R')))
  -> ((lookupCT ct L_notjhi A_notjhi)
  /\ ((s:state)(T_notjhi Pred f s) -> (A_notjhi s)))
  -> ((lookupCT ct L_trylo A_trylo)
  /\ ((s:state)(T_trylo Pred f s) -> (A_trylo s)))
  -> (Infer ct (T_tryhi Pred f) C_tryhi).
Proof.
Intros; Unfold C_tryhi; Unfold T_tryhi.
(* ld cursize hp(size) *)
Apply I_ld with
 [s:(heap*rfile)]
 (EX lnk:nat |
   (EX siz:nat |
     (((((star
               (star Pred (MBlk (plus (2) (getValinR s r4)) lnk siz))
               (MidL (getValinR s r2) (getValinR s r5)
		 (getValinR s r6)) s)
		  /\(getValinR s r0)=f)
		  /\((lt (getValinR s r5) (getValinR s r4))
		  \/(getValinR s r5)=(0)))
		  /\~(getValinR s r6)=(0))
		  /\(lt (getValinR s r4) (getValinR s r6)))
		  /\((getValinR s cursize)=siz))).
Unfold updateR; Unfold getValinR.
Unfold lookupR; Fold lookupR; Unfold beq_reg.
Intros.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Exists x0.
Constructor.
Apply Read_Star_MBlk_siz
    with R x (star Pred (MidL (lookupR R r2) (lookupR R r5) (lookupR R r6))).
Apply star_assoc_L.
Apply star_subst with (star Pred (MBlk (plus (2) (lookupR R r4)) x x0))
    (MidL (lookupR R r2) (lookupR R r5) (lookupR R r6)); Auto.
Intros.
Apply star_sym.
Unfold plus; Unfold plus in H5; Auto.
Exists x; Exists x0.
Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intros.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply H0.
Intro; Apply MBlk_RF_Insensitive.
Intro; Apply MidL_RF_Insensitive.
(* add curend hp cursize *)
Apply I_add with
    [s:(heap*rfile)]
    (EX lnk:nat |
      (EX siz:nat |
        (((((star
                  (star Pred (MBlk (plus (2) (getValinR s r4)) lnk siz))
                  (MidL (getValinR s r2) (getValinR s r5)
                    (getValinR s r6)) s)/\(getValinR s r0)=f)
		     /\((lt (getValinR s r5) (getValinR s r4))
                     \/(getValinR s r5)=(0)))/\~(getValinR s r6)=(0))
		     /\(lt (getValinR s r4) (getValinR s r6)))
		     /\(getValinR s r8)=siz))
		     /\((getValinR s curend)
		     =(plus (getValinR s hp) (getValinR s cursize))).
Unfold updateR; Unfold getValinR.
Unfold lookupR; Fold lookupR; Unfold beq_reg.
Intros; Constructor; Auto.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Exists x; Exists x0.
Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intros; Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply H0.
Intro; Apply MBlk_RF_Insensitive.
Intro; Apply MidL_RF_Insensitive.
(* bgt p curend notjhi *)
Apply I_bgt with
    [s:(heap*rfile)]
    (EX lnk:nat |
      (((((star
		(star Pred
		  (MBlk (plus (2) (getValinR s r4)) lnk (getValinR s cursize)))
                (MidL (getValinR s r2) (getValinR s r5) (getValinR s r6)) s)
		 /\(getValinR s r0)=f)
		 /\((lt (getValinR s r5) (getValinR s r4))
                 \/(getValinR s r5)=(0)))
		 /\~(getValinR s r6)=(0))
		 /\(getValinR s p)=
	(plus (getValinR s hp) (getValinR s cursize))))
    A_notjhi.
Inversion_clear H1; Auto.
Unfold getValinR.
Intros.
Inversion_clear H5.
Inversion_clear H6.
Inversion_clear H5.
Inversion_clear H6.
Inversion_clear H5.
Inversion_clear H6.
Inversion_clear H5.
Inversion_clear H6.
Exists x.
Rewrite <- H8 in H5.
Constructor; Auto.
Rewrite H7 in H4.
Cut (~((le (lookupR R r4) (lookupR R r6))
    /\ (lt (lookupR R r6) (plus (lookupR R r4) (lookupR R r8))))).
Intro Occupied; Unfold not in Occupied.
Cut (lt (lookupR R r6) (plus (lookupR R r4) (lookupR R r8)))
    \/ (lookupR R r6)=(plus (lookupR R r4) (lookupR R r8)).
Intro Or; Case Or; Auto.
Intros; Cut False.
Intro FF; Inversion FF.
Apply Occupied.
Constructor; Auto.
Apply lt_le_weak; Auto.
Apply le_lt_or_eq; Auto.
Apply Star_MBlk_Occupied with (H3,R) x
   (star Pred (MidL (lookupR R r2) (lookupR R r5) (lookupR R r6))).
Apply star_assoc_L.
Apply star_subst
    with (star Pred (MBlk (plus (2) (lookupR R r4)) x (lookupR R r8)))
   (MidL (lookupR R r2) (lookupR R r5) (lookupR R r6)); Auto.
Intro; Apply star_sym.
Intros; Apply Star_MidL_indom_Q
    with R (lookupR R r2) (lookupR R r5) Pred; Auto.
Apply star_sym; Apply RF_Insensitive_Distrib_Star with R0; Auto.
Intro; Apply H0.
Intro; Apply MidL_RF_Insensitive.
Intros; Inversion_clear H1.
Apply H7.
Unfold T_notjhi; Unfold getValinR; Intros.
Inversion_clear H5.
Inversion_clear H1.
Inversion_clear H5.
Inversion_clear H1.
Inversion_clear H5.
Inversion_clear H1.
Exists x; Exists x0; Constructor; Auto.
Unfold getValinR in H8; Unfold getValinR in H9.
Rewrite H9 in H8; Rewrite H8 in H4; Auto.
(* ld psize p(size) *)
Apply I_ld with
   [s:state]
   (EX lnk | (EX siz' | (EX q | (EX n |
   ((((((star
     (star (MBlk (plus (2) (getValinR s hp)) lnk (getValinR s cursize))
       (MBlk (plus (2) (getValinR s p)) q siz'))
     (star
       (star Pred
	   (EndL (getValinR s flist) (getValinR s prev) (getValinR s p)))
       (MBlkLst n q pnil))
	s)
	/\((getValinR s r0)=f))
        /\((lt (getValinR s r5) (getValinR s r4))
        \/(getValinR s r5)=(0)))
	/\((lt (getValinR s p) q)\/q=O))
	/\(~(getValinR s r6)=(0)))
	/\((getValinR s r6)=(plus (getValinR s r4) (getValinR s cursize))))
	/\((getValinR s psize)=siz'))))).
Unfold updateR; Unfold getValinR. 
Unfold lookupR; Fold lookupR; Unfold beq_reg.
Intros.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Cut (EX m:nat | (EX q:addr | (EX siz':nat |
(star (star Pred (MBlk (plus (2) (lookupR R r4)) x (lookupR R r8)))
  (star (EndL (lookupR R r2) (lookupR R r5) (lookupR R r6))
    (star (MBlk (plus (2) (lookupR R p)) q siz') (MBlkLst m q (0)))
  ) (H3,R))
     /\ ((lt (lookupR R p) q)\/q=O)))).
Clear H5; Intro H5.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Exists x2.
Constructor.
Apply Read_Star_MBlk_siz with R x1
(star
  (star Pred (MBlk (plus (2) (lookupR R r4)) x (lookupR R r8)))
  (star
    (EndL (lookupR R r2) (lookupR R r5) (lookupR R r6))
    (MBlkLst x0 x1 (0)))).
Apply star_sym.
Apply star_assoc_R.
Apply star_subst with 
(star Pred (MBlk (plus (2) (lookupR R r4)) x (lookupR R r8)))
(star (EndL (lookupR R r2) (lookupR R r5) (lookupR R r6))
           (star (MBlk (plus (2) (lookupR R r6)) x1 x2)
	     (MBlkLst x0 x1 (0)))); Auto.
Clear H5; Intros.
Apply star_assoc_R.
Apply star_subst with
	 (EndL (lookupR R r2) (lookupR R r5) (lookupR R r6))
	 (star (MBlk (plus (2) (lookupR R r6)) x1 x2) (MBlkLst x0 x1 (0)));
	  Auto.
Clear H4; Intros.
Apply star_sym; Auto.
Exists x; Exists x2; Exists x1; Exists x0.
Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R.
Clear H5; Intros; Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply MBlk_RF_Insensitive.
Intro; Apply MBlk_RF_Insensitive.
Clear H5; Intros; Apply RF_Insensitive_Distrib_Star with R; Auto.
Clear H5; Intros; Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply H0.
Intro; Apply EndL_RF_Insensitive.
Intro; Apply MBlkLst_RF_Insensitive.
Apply star_assoc_R.
Apply star_subst with (MBlk (plus (2) (lookupR R r4)) x (lookupR R r8))
     (star Pred
         (star (EndL (lookupR R r2) (lookupR R r5) (lookupR R r6))
           (star (MBlk (plus (2) (lookupR R r6)) x1 x2)
             (MBlkLst x0 x1 (0))))); Auto.
Apply star_assoc_L.
Apply star_subst
    with (star Pred (MBlk (plus (2) (lookupR R r4)) x (lookupR R r8)))
       (star (EndL (lookupR R r2) (lookupR R r5) (lookupR R r6))
         (star (MBlk (plus (2) (lookupR R r6)) x1 x2)
           (MBlkLst x0 x1 (0)))); Auto.
Intros; Apply star_sym; Auto.
Clear H5; Intros.
Apply star_assoc_L.
Apply star_subst with 
	 (star (star Pred (EndL (lookupR R r2) (lookupR R r5) (lookupR R r6)))
	   (MBlk (plus (2) (lookupR R r6)) x1 x2))
	 (MBlkLst x0 x1 (0)); Auto.
Apply star_assoc_R.
Apply star_assoc_R.
Assumption.
Clear H4; Intros; Apply star_sym; Auto.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H10.
Inversion_clear H11.
Inversion_clear H12.
Inversion_clear H11.
Inversion_clear H12.
Inversion_clear H11.
Inversion_clear H13.
Inversion_clear H14.
Inversion H15.
Absurd (lookupR R r6)=O; Assumption.
Exists n; Exists p'; Exists s.
Constructor; Auto.
Unfold star.
Inversion_clear H10.
Inversion_clear H28.
Inversion_clear H10.
Inversion_clear H29.
Inversion_clear H30.
Exists x0; Exists x1.
Constructor; Auto.
Constructor; Auto.
Constructor.
Exists x5; Exists x6.
Constructor; Auto.
Exists x3; Exists x4.
Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Exists H16; Exists H17.
Constructor; Auto.
(* add newsize cursize psize *)
Apply I_add with
     [s:(heap*rfile)]
      (EX lnk:nat |
            (EX siz':nat |
               (EX q:nat |
                  (EX n:nat |
                     ((((((star
                           (star
                             (MBlk (plus (2) (getValinR s r4)) lnk
			       (getValinR s r8))
                             (MBlk (plus (2) (getValinR s r6)) q siz'))
                           (star
                             (star Pred
                               (EndL (getValinR s r2) (getValinR s r5)
                                 (getValinR s r6))) (MBlkLst n q (0)))
                           s)/\(getValinR s r0)=f)
                        /\((lt (getValinR s r5) (getValinR s r4))
                           \/(getValinR s r5)=(0)))
                        /\((lt (getValinR s r6) q)\/q=(0)))
                       /\~(getValinR s r6)=(0))
                      /\(getValinR s r6)
				  =(plus (getValinR s r4) (getValinR s r8)))
                     /\(getValinR s r10)=siz'))))
/\ ((getValinR s newsize)=(plus (getValinR s cursize) (getValinR s psize))).
Unfold updateR; Unfold getValinR.
Unfold lookupR; Fold lookupR; Unfold beq_reg.
Constructor; Auto.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Exists x; Exists x0; Exists x1; Exists x2.
Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intros; Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply MBlk_RF_Insensitive.
Intro; Apply MBlk_RF_Insensitive.
Intros; Apply RF_Insensitive_Distrib_Star with R; Auto.
Intros; Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply H0.
Intros; Apply EndL_RF_Insensitive with R; Auto.
Intros; Apply MBlkLst_RF_Insensitive with R; Auto.
(* st hp(size) newsize *)
Apply I_st with
     [s:(heap*rfile)]
      (EX lnk:nat |
            (EX siz':nat |
               (EX q:nat |
                  (EX n:nat |
                     ((((((star
                       (MBlk (plus (2) (getValinR s r4)) lnk (getValinR s r11))
                       (star
                         (star Pred
                           (EndL (getValinR s r2) (getValinR s r5)
                             (getValinR s r6))) (MBlkLst n q (0)))
                       s)/\(getValinR s r0)=f)
                    /\((lt (getValinR s r5) (getValinR s r4))
                       \/(getValinR s r5)=(0)))
                    /\((lt (getValinR s r6) q)\/q=(0)))
                    /\~(getValinR s r6)=(0))
                    /\(getValinR s r6)
			      =(plus (getValinR s r4) (getValinR s r8)))
                    /\(getValinR s r10)=siz')
		    /\(getValinH s (getValinR s p))=(hvsome q))))
      /\(getValinR s r11)=(plus (getValinR s r8) (getValinR s r10)).
Unfold getValinH; Unfold getValinR.
Intros.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Cut (star (MBlk (plus (2) (lookupR R r4)) x (lookupR R r8))
	(star (MBlk (plus (2) (lookupR R r6)) x1 x0)
         (star
           (star Pred
             (EndL (lookupR R r2) (lookupR R r5) (lookupR R r6)))
           (MBlkLst x2 x1 (0)))) (H3,R)).
Clear H5; Intro H5.
Constructor.
Apply Star_MBlk_indom with R x (lookupR R r8)
         (star (MBlk (plus (2) (lookupR R r6)) x1 x0)
           (star
             (star Pred
               (EndL (lookupR R r2) (lookupR R r5) (lookupR R r6)))
             (MBlkLst x2 x1 (0)))); Auto.
Apply lt_trans with (2); Auto.
Apply gt_lt.
Apply Star_MBlk_siz_gt_2 with (H3,R) (plus (2) (lookupR R r4)) x
         (star (MBlk (plus (2) (lookupR R r6)) x1 x0)
           (star
             (star Pred
               (EndL (lookupR R r2) (lookupR R r5) (lookupR R r6)))
             (MBlkLst x2 x1 (0)))); Auto.
Constructor; Auto.
Exists x; Exists x0; Exists x1.
Constructor.
Exists x2.
Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Rewrite H6.
Apply Write_Star_MBlk_siz.
Apply star_subst with 
(star (MBlk (plus (2) (lookupR R r4)) x (lookupR R r8))
  (MBlk (plus (2) (lookupR R r6)) x1 x0))
(star
  (star Pred (EndL (lookupR R r2) (lookupR R r5) (lookupR R r6)))
  (MBlkLst x2 x1 (0))); Auto.
Apply star_assoc_R; Auto.
Clear H5; Intros.
Apply star_subst with 
(MBlk (plus (2) (lookupR R r4)) x (lookupR R r8))
(MBlk (plus (2) (lookupR R r6)) x1 x0); Auto.
Clear H4; Intros.
Rewrite <- H8; Rewrite H7.
Apply MBlk_ptoanylist with x1; Auto.
Replace (Some nat x1) with (hread H3 (lookupR R r6)).
Apply local_write.
Rewrite H8.
Intro CONTRA.
Absurd ((lookupR R r8)=(1)).
Intro C2.
Cut (gt (lookupR R r8) (2)).
Intro C3; Rewrite C2 in C3.
Inversion_clear C3.
Inversion_clear H4.
Apply Star_MBlk_siz_gt_2 with (H3,R) (plus (2) (lookupR R r4)) x
         (star (MBlk (plus (2) (lookupR R r6)) x1 x0)
           (star
             (star Pred
               (EndL (lookupR R r2) (lookupR R r5) (lookupR R r6)))
             (MBlkLst x2 x1 (0)))); Auto.
Apply simpl_plus_l with (lookupR R r4).
Apply trans_eq with (plus (1) (lookupR R r4)); Auto with arith.
Apply Read_Star_MBlk_lnk with R x0
(star (MBlk (plus (2) (lookupR R r4)) x (lookupR R r8))
  (star
    (star Pred
      (EndL (lookupR R r2) (lookupR R r5) (lookupR R r6)))
    (MBlkLst x2 x1 (0)))).
Apply star_assoc_L.
Apply star_subst with
       (star (MBlk (plus (2) (lookupR R r4)) x (lookupR R r8))
	 (MBlk (plus (2) (lookupR R r6)) x1 x0))
       (star
	 (star Pred (EndL (lookupR R r2) (lookupR R r5) (lookupR R r6)))
	 (MBlkLst x2 x1 (0))); Auto.
Apply star_assoc_R; Auto.
Intros; Apply star_sym; Auto.
Apply star_assoc_L; Auto.
(* ld plink p(link) *)
Apply I_ld with
[s:(heap*rfile)]
(EX lnk:nat |
(EX siz':nat |
  (EX q:nat |
    (EX n:nat |
      ((((((star
                (MBlk (plus (2) (getValinR s r4)) lnk
                  (getValinR s r11))
                (star
                  (star Pred
                    (EndL (getValinR s r2) (getValinR s r5)
                      (getValinR s r6))) (MBlkLst n q (0))) s)
		       /\(getValinR s r0)=f)
		       /\((lt (getValinR s r5) (getValinR s r4))
                       \/(getValinR s r5)=(0)))
                       /\((lt (getValinR s r6) q)\/q=(0)))
		       /\~(getValinR s r6)=(0))
		       /\(getValinR s r6)
		       =(plus (getValinR s r4) (getValinR s r8)))
		       /\(getValinR s r10)=siz')/\((getValinR s plink)=q))))
		       /\((getValinR s r11)
		       =(plus (getValinR s r8) (getValinR s r10))).
Unfold updateR; Unfold getValinR; Unfold getValinH.
Unfold lookupR; Fold lookupR; Unfold beq_reg.
Intros.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Exists x1; Constructor.
Unfold plus; Assumption.
Constructor; Auto.
Exists x; Exists x0; Exists x1.
Constructor; Auto.
Exists x2.
Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply MBlk_RF_Insensitive.
Intros; Apply RF_Insensitive_Distrib_Star with R; Auto.
Intros; Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply H0.
Intro; Apply EndL_RF_Insensitive.
Intro; Apply MBlkLst_RF_Insensitive.
(* st hp(link) plink *)
Apply I_st with 
     [s:(heap*rfile)]
      (EX siz:nat |
        (EX q:nat |
          (EX n:nat |
            ((((star
                    (MBlk (plus (2) (getValinR s r4)) q siz)
                    (star
                      (star Pred
                        (EndL (getValinR s r2) (getValinR s r5)
                          (getValinR s r6))) (MBlkLst n q (0))) s)
			   /\(getValinR s r0)=f)
			   /\((lt (getValinR s r5) (getValinR s r4))
                           \/(getValinR s r5)=(0)))
			   /\((lt (getValinR s r4) q)\/q=(0)))))).
Unfold getValinR; Unfold getValinH.
Intros.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Constructor.
Apply Star_MBlk_indom with R x (lookupR R r11)
	 (star
           (star Pred
             (EndL (lookupR R r2) (lookupR R r5) (lookupR R r6)))
           (MBlkLst x2 x1 (0))); Auto.
Apply lt_trans with (2); Auto with arith.
Apply gt_lt.
Apply Star_MBlk_siz_gt_2 with (H3,R) (plus (2) (lookupR R r4)) x
	 (star
           (star Pred
             (EndL (lookupR R r2) (lookupR R r5) (lookupR R r6)))
           (MBlkLst x2 x1 (0))); Auto.
Exists (lookupR R r11); Exists x1; Exists x2.
Constructor.
Constructor; Auto.
Constructor; Auto.
Rewrite H7; Apply Write_Star_MBlk_lnk with x; Auto.
Inversion_clear H11.
Left.
Apply le_lt_trans with (lookupR R r6); Auto.
Rewrite H9.
Apply le_plus_l.
Right; Assumption.
(* jd trylo *)
Inversion_clear H2.
Apply I_jd with A_trylo; Auto.
Intros; Apply H4.
Unfold T_trylo.
Inversion_clear H2.
Inversion_clear H5.
Inversion_clear H2.
Inversion_clear H5.
Inversion_clear H2.
Inversion_clear H5.
Exists (getValinR s r6); Exists x1.
Constructor; Auto.
Constructor; Auto.
Apply star_subst with
	 (star Pred
	   (EndL (getValinR s r2) (getValinR s r5) (getValinR s r6)))
	 (star (MBlk (plus (2) (getValinR s r4)) x0 x)
	   (MBlkLst x1 x0 (0))); Auto.
Apply star_sym.
Apply star_assoc_R.
Apply star_subst with
	 (MBlk (plus (2) (getValinR s r4)) x0 x)
         (star
           (star Pred
             (EndL (getValinR s r2) (getValinR s r5) (getValinR s r6)))
           (MBlkLst x1 x0 (0))); Auto.
Intros; Apply star_sym; Auto.
Clear H2; Intros.
Induction s0; Inversion_clear H2.
Inversion_clear H5.
Inversion_clear H2.
Inversion_clear H9.
Inversion_clear H10.
Apply mbl_S with x2 x3 x x0; Auto.
Save.

Theorem WF_notjhi : (Pred:assert; ct:codeheapty; f:lab; A_trylo:assert)
 ((s:state)(Q_free Pred s) ->
   (exT assert ([A:assert](lookupCT ct f A) /\ (A s))))
  -> ((H:heap;R,R':rfile)(Pred (H,R)) -> (Pred (H,R')))
  -> ((lookupCT ct L_trylo A_trylo)
  /\ ((s:state)(T_trylo Pred f s) -> (A_trylo s)))
  -> (Infer ct (T_notjhi Pred f) C_notjhi).
Proof.
Intros; Unfold C_notjhi; Unfold T_notjhi.
(* st hp(link) p *)
Apply I_st with
 [s:(heap*rfile)]
 (EX siz:nat | (EX n:nat |
   (((star
         (star Pred (MBlk (plus (2) (getValinR s r4)) (getValinR s p) siz))
	(star
         (EndL (getValinR s r2) (getValinR s r5) (getValinR s r6))
	 (MBlkLst n (getValinR s p) pnil))
	  s)
	    /\(getValinR s r0)=f)
            /\((lt (getValinR s r5) (getValinR s r4))
            \/(getValinR s r5)=(0)))
            /\(lt (getValinR s r4) (getValinR s r6)))).
Unfold getValinR; Intros.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H3.
Constructor.
Cut (star (MBlk (plus (2) (lookupR R r4)) x x0)
     (star Pred (MidL (lookupR R r2) (lookupR R r5) (lookupR R r6)))
     (H2,R)).
Clear H4; Intro H4.
Apply Star_MBlk_indom with R x x0
(star Pred (MidL (lookupR R r2) (lookupR R r5) (lookupR R r6))); Auto.
Apply lt_trans with (2); Auto with arith.
Apply Star_MBlk_siz_gt_2 with (H2,R) (plus (2) (lookupR R r4)) x 
(star Pred (MidL (lookupR R r2) (lookupR R r5) (lookupR R r6))); Auto.
Apply star_assoc_L.
Apply star_subst with
(star Pred (MBlk (plus (2) (lookupR R r4)) x x0))
(MidL (lookupR R r2) (lookupR R r5) (lookupR R r6)); Auto.
Intro; Apply star_sym.
Exists x0; Cut (EX n | (star
        (star Pred
          (MBlk (plus (2) (lookupR R r4)) (lookupR R r6) x0))
        (star (EndL (lookupR R r2) (lookupR R r5) (lookupR R r6))
          (MBlkLst n (lookupR R r6) (0)))
        ((hwrite H2 (plus (0) (lookupR R r4)) (lookupR R r6)),R))).
Clear H4; Intros.
Inversion_clear H3.
Exists x1.
Constructor; Auto.
Apply gt_lt.
Apply gt_le_trans with (plus (lookupR R r4) x0); Auto with arith.
Cut (EX n | (star
        (star Pred (MBlk (plus (2) (lookupR R r4)) x x0))
        (star (EndL (lookupR R r2) (lookupR R r5) (lookupR R r6))
          (MBlkLst n (lookupR R r6) (0)))
        (H2,R))).
Clear H4; Intro H4; Inversion_clear H4.
Exists x1.
Apply star_subst with
    (star (MBlk (plus (2) (lookupR R r4)) (lookupR R r6) x0) Pred)
    (star (EndL (lookupR R r2) (lookupR R r5) (lookupR R r6))
      (MBlkLst x1 (lookupR R r6) (0))); Auto.
Apply star_assoc_R.
Apply Write_Star_MBlk_lnk with x.
Apply star_assoc_L.
Apply star_subst with
    (star Pred (MBlk (plus (2) (lookupR R r4)) x x0))
    (star (EndL (lookupR R r2) (lookupR R r5) (lookupR R r6))
      (MBlkLst x1 (lookupR R r6) (0))); Auto.
Intro; Apply star_sym.
Intro; Apply star_sym.
Cut (EX n |(star
        (star (EndL (lookupR R r2) (lookupR R r5) (lookupR R r6))
          (MBlkLst n (lookupR R r6) (0)))
        (star Pred (MBlk (plus (2) (lookupR R r4)) x x0))
        (H2,R))).
Clear H4; Intro H4; Inversion_clear H4.
Exists x1.
Apply star_sym; Auto.
Apply Star_Unfold_MidL.
Apply star_sym; Auto.
(* jd trylo *)
Inversion_clear H1.
Apply I_jd with A_trylo; Auto.
Intros; Apply H3.
Unfold T_trylo.
Inversion_clear H1.
Inversion_clear H4.
Inversion_clear H1.
Inversion_clear H4.
Inversion_clear H1.
Exists (getValinR s r6); Exists x0.
Constructor; Auto.
Constructor; Auto.
Apply star_subst with
    (star Pred (EndL (getValinR s r2) (getValinR s r5) (getValinR s r6)))
    (star (MBlk (plus (2) (getValinR s r4)) (getValinR s r6) x)
      (MBlkLst x0 (getValinR s r6) (0))); Auto.
Apply star_assoc_R.
Apply star_subst with Pred
     (star (MBlk (plus (2) (getValinR s r4)) (getValinR s r6) x)
       (star (EndL (getValinR s r2) (getValinR s r5) (getValinR s r6))
         (MBlkLst x0 (getValinR s r6) (0)))); Auto.
Apply star_assoc_L; Auto.
Clear H4; Intros.
Apply star_assoc_L.
Apply star_subst with
     (star (MBlk (plus (2) (getValinR s r4)) (getValinR s r6) x)
       (EndL (getValinR s r2) (getValinR s r5) (getValinR s r6)))
     (MBlkLst x0 (getValinR s r6) (0)); Auto.
Apply star_assoc_R; Auto.
Clear H1; Apply star_sym.
Clear H4; Intros.
Apply Compose_MBlk_MBlkLst_to_MBlkLst with (getValinR s r6) x; Auto.
Save.

Theorem WF_trylo : (Pred:assert; ct:codeheapty; f:lab; A_lnklo:assert)
 ((s:state)(Q_free Pred s) ->
   (exT assert ([A:assert](lookupCT ct f A) /\ (A s))))
  -> ((H:heap;R,R':rfile)(Pred (H,R)) -> (Pred (H,R')))
  -> ((lookupCT ct L_lnklo A_lnklo)
  /\ ((s:state)(T_lnklo Pred f s) -> (A_lnklo s)))
  -> (Infer ct (T_trylo Pred f) C_trylo).
Proof.
Intros; Unfold T_trylo; Unfold C_trylo.
(* bgti prev nil lnklo *)
Apply I_bgti with [s:(heap*rfile)]
 (EX lnk:nat |
   (EX n:nat |
     ((star
         (star Pred (EndL (getValinR s r2) (getValinR s r5) lnk))
         (MBlkLst (S n) (getValinR s r4) (0)) s)
          /\(getValinR s r0)=f)
          /\((getValinR s r5)=pnil)))
 A_lnklo.
Inversion_clear H1; Auto.
Intros.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Exists x; Exists x0.
Constructor; Auto.
Unfold getValinR.
Inversion_clear H3; Trivial.
Unfold getValinR; Intros.
Inversion_clear H1.
Apply H6.
Unfold T_lnklo.
Inversion_clear H4.
Inversion_clear H1.
Exists x; Exists x0.
Inversion_clear H4.
Inversion_clear H1.
Cut (EX m | (EX siz |
               ((star
                  (star Pred
                    (star
                      (MBlkLst m (getValinR (H2,R) r2)
                        (getValinR (H2,R) r5))
                      (MBlk (plus (2) (getValinR (H2,R) r5)) x siz)))
                  (MBlkLst (S x0) (getValinR (H2,R) r4) (0)) (H2,R))))).
Clear H4; Intro H4.
Inversion_clear H4.
Inversion_clear H1.
Exists x1; Exists x2.
Constructor; Auto.
Unfold getValinR; Cut (~(lookupR R r5)=O).
Intro; Constructor; Auto.
Inversion_clear H7; Auto.
Absurd (lookupR R r5)=O; Auto.
Inversion_clear H3; Auto.
Cut (EX m:nat | (EX siz:nat |
              (star
		(star
		  (MBlkLst m (getValinR (H2,R) r2) (getValinR (H2,R) r5))
		  (MBlk (plus (2) (getValinR (H2,R) r5)) x siz))
		(star Pred
		  (MBlkLst (S x0) (getValinR (H2,R) r4) (0))) (H2,R)))).
Clear H4; Unfold getValinR; Intros.
Inversion_clear H1.
Inversion_clear H4.
Exists x1; Exists x2.
Apply star_subst with
(star (star (MBlkLst x1 (lookupR R r2) (lookupR R r5))
    (MBlk (plus (2) (lookupR R r5)) x x2))
     Pred)
(MBlkLst (S x0) (lookupR R r4) (0)); Auto.
Apply star_assoc_R; Assumption.
Clear H1; Intros; Apply star_sym; Auto.
Unfold getValinR; Apply proj1 with ((lt (lookupR R r5) x)\/(x=pnil)).
Apply Star_Unfold_EndL.
Apply star_assoc_L.
Apply star_subst with (star Pred (EndL (lookupR R r2) (lookupR R r5) x))
(MBlkLst (S x0) (lookupR R r4) (0)); Auto.
Intro; Apply star_sym.
Intro EQO; Rewrite EQO in H3; Inversion H3.
(* mov flist hp *)
Apply I_mov with [s:state]
(star Pred (Good (getValinR s flist)) s)
 /\ (getValinR s ret0)=f.
Unfold updateR; Unfold getValinR.
Unfold lookupR; Fold lookupR; Unfold beq_reg.
Intros.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H3.
Inversion_clear H4.
Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R.
Intro; Apply H0.
Intro; Apply Good_RF_Insensitive.
Apply star_subst with Pred
(star (EndL (lookupR R r2) (lookupR R r5) x)
  (MBlkLst (S x0) (lookupR R r4) (0))); Auto.
Apply star_assoc_L; Auto.
Clear H3; Intros.
Apply star_emp.
Apply star_subst with (EndL (lookupR R r2) (lookupR R r5) x)
(MBlkLst (S x0) (lookupR R r4) (0)); Auto.
Clear H3; Intros.
Inversion_clear H3.
Cut (MBlkLst O (lookupR R r2) x s1); Auto.
Intro MBLK; Inversion_clear MBLK; Auto.
Clear H3; Intros; Unfold Good.
Exists (S x0); Auto.
Intros until R0; Apply h_subst_Good.
(* jmp ret0 *)
Apply I_jmp.
Intros.
Inversion_clear H3.
Unfold getValinR in H5; Rewrite H5; Apply H.
Unfold Q_free; Auto.
Save.

Theorem WF_lnklo : (Pred:assert; ct:codeheapty; f:lab; A_notjlo:assert)
 ((s:state)(Q_free Pred s) ->
   (exT assert ([A:assert](lookupCT ct f A) /\ (A s))))
  -> ((H:heap;R,R':rfile)(Pred (H,R)) -> (Pred (H,R')))
  -> ((lookupCT ct L_notjlo A_notjlo)
  /\ ((s:state)(T_notjlo Pred f s) -> (A_notjlo s)))
  -> (Infer ct (T_lnklo Pred f) C_lnklo).
Proof.
Intros; Unfold C_lnklo; Unfold T_lnklo.
(* ld prevsize prev(size) *)
Apply I_ld with
 [s:(heap*rfile)]
 (EX lnk:nat | (EX n:nat | (EX m:nat |
       ((star
           (star Pred
             (star
               (MBlkLst m (getValinR s r2) (getValinR s r5))
               (MBlk (plus (2) (getValinR s r5)) lnk
		 (getValinR s prevsize))))
           (MBlkLst (S n) (getValinR s r4) (0)) s)
            /\(getValinR s r0)=f)
            /\(lt (getValinR s r5) (getValinR s r4))
            /\~(getValinR s r5)=(0)))).
Unfold getValinR; Unfold updateR; Unfold getValinR; Intros.
Unfold lookupR; Fold lookupR; Unfold beq_reg.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H3.
Inversion_clear H4.
Exists x2.
Constructor.
Apply Read_Star_MBlk_siz with R x
 (star (star Pred
     (MBlkLst x1 (lookupR R r2) (lookupR R r5)))
   (MBlkLst (S x0) (lookupR R r4) (0))).
Apply star_assoc_L.
Apply star_subst with
     (star Pred
       (star (MBlkLst x1 (lookupR R r2) (lookupR R r5))
         (MBlk (plus (2) (lookupR R r5)) x x2)))
     (MBlkLst (S x0) (lookupR R r4) (0)); Auto.
Clear H3; Intros.
Apply star_assoc_L.
Apply star_subst with
     (star Pred  (MBlk (plus (1) (plus (1) (lookupR R r5))) x x2))
     (MBlkLst x1 (lookupR R r2) (lookupR R r5)); Auto.
Apply star_assoc_R.
Apply star_subst with Pred
     (star (MBlkLst x1 (lookupR R r2) (lookupR R r5))
       (MBlk (plus (2) (lookupR R r5)) x x2)); Auto.
Clear H3; Intro; Apply star_sym.
Intro; Apply star_sym.
Exists x; Exists x0; Exists x1.
Constructor; Auto.
Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply RF_Insensitive_Distrib_Star.
Intro; Apply H0.
Intro; Apply RF_Insensitive_Distrib_Star.
Intro; Apply MBlkLst_RF_Insensitive.
Intro; Apply MBlk_RF_Insensitive.
Intro; Apply MBlkLst_RF_Insensitive.
(* add prevend prev prevsize *)
Apply I_add with [s:(heap*rfile)]
     (EX lnk:nat | (EX n:nat | (EX m:nat |
           ((star
               (star Pred
                 (star (MBlkLst m (getValinR s r2) (getValinR s r5))
                   (MBlk (plus (2) (getValinR s r5)) lnk
                     (getValinR s r13))))
               (MBlkLst (S n) (getValinR s r4) (0)) s)
                /\(getValinR s r0)=f)
		/\(lt (getValinR s r5) (getValinR s r4))
                /\~(getValinR s r5)=(0))))
		/\(getValinR s prevend)
		=(plus (getValinR s prev) (getValinR s prevsize)).
Unfold updateR; Unfold getValinR.
Unfold lookupR; Fold lookupR; Unfold beq_reg.
Intros; Constructor; Auto.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H3.
Exists x; Exists x0; Exists x1.
Constructor; Auto.
Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply RF_Insensitive_Distrib_Star.
Intro; Apply H0.
Intro; Apply RF_Insensitive_Distrib_Star.
Intro; Apply MBlkLst_RF_Insensitive.
Intro; Apply MBlk_RF_Insensitive.
Intro; Apply MBlkLst_RF_Insensitive.
(* bgt hp prevend notjlo *)
Apply I_bgt with [s:(heap*rfile)]
  (EX lnk:nat | (EX n:nat | (EX m:nat |
        ((star
            (star Pred
              (star (MBlkLst m (getValinR s r2) (getValinR s r5))
                (MBlk (plus (2) (getValinR s r5)) lnk
                  (getValinR s r13))))
            (MBlkLst (S n) (getValinR s r4) (0)) s)
             /\((getValinR s r0)=f)
	     /\(lt (getValinR s r5) (getValinR s r4)))
	     /\(getValinR s hp)=(plus (getValinR s r5) (getValinR s r13)))))
  A_notjlo.
Inversion_clear H1; Auto.
Unfold getValinR; Intros.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H4.
Inversion_clear H5.
Inversion_clear H7.
Exists x; Exists x0; Exists x1.
Constructor.
Constructor; Auto.
Rewrite <- H6.
Cut ((lt (lookupR R r4) (lookupR R r14))\/(lookupR R r4)=(lookupR R r14)).
Intro OR; Case OR; Auto.
Clear OR; Intro.
Cut (~((le (lookupR R r5) (lookupR R r4))
   /\ (lt (lookupR R r4) (plus (lookupR R r5) (lookupR R r13))))).
Intros.
Unfold not in H10; Rewrite <- H6 in H10.
Cut False.
Intro FF; Inversion FF.
Apply H10; Constructor; Auto.
Apply lt_le_weak; Auto.
Apply Star_MBlk_Occupied with (H2,R) x
  (star (star Pred
      (MBlkLst x1 (lookupR R r2) (lookupR R r5)))
    (MBlkLst (S x0) (lookupR R r4) (0))).
Apply star_assoc_L.
Apply star_subst with
  (star Pred
    (star (MBlkLst x1 (lookupR R r2) (lookupR R r5))
      (MBlk (plus (2) (lookupR R r5)) x (lookupR R r13))))
  (MBlkLst (S x0) (lookupR R r4) (0)); Auto.
Clear H4; Intros.
Apply star_assoc_L.
Apply star_subst with
  (star Pred (MBlk (plus (2) (lookupR R r5)) x (lookupR R r13)))
  (MBlkLst x1 (lookupR R r2) (lookupR R r5)); Auto.
Apply star_assoc_R.
Apply star_subst with Pred
  (star (MBlkLst x1 (lookupR R r2) (lookupR R r5))
    (MBlk (plus (2) (lookupR R r5)) x (lookupR R r13))); Auto.
Intro; Apply star_sym.
Intro; Apply star_sym.
Clear H4; Intros.
Replace (lookupR R r4) with (plus (0) (lookupR R r4)); Auto with arith.
Cut (star (MBlkLst (S x0) (lookupR R r4) (0))
    (star Pred (MBlkLst x1 (lookupR R r2) (lookupR R r5))) (H4,R0)).
Clear H10; Intros.
Apply Star_MBlkLst_indom with R0 (S x0) O
  (star Pred (MBlkLst x1 (lookupR R r2) (lookupR R r5))); Auto.
Unfold plus.
Intro; Absurd (gt (lookupR R r4) O).
Rewrite H11; Intro FF; Inversion FF.
Apply Star_MBlkLst_S_ptr_gt_O with (H4,R0) x0 O
  (star Pred (MBlkLst x1 (lookupR R r2) (lookupR R r5))); Auto.
Apply star_assoc_L.
Apply star_subst with
  (star Pred (MBlkLst (S x0) (lookupR R r4) (0)))
  (MBlkLst x1 (lookupR R r2) (lookupR R r5)); Auto.
Apply star_assoc_R.
Apply star_subst with Pred
  (star (MBlkLst x1 (lookupR R r2) (lookupR R r5))
    (MBlkLst (S x0) (lookupR R r4) (0))); Auto.
Apply star_assoc_L; Auto.
Intro; Apply star_sym.
Intro; Apply star_sym.
Apply le_lt_or_eq; Auto.
Unfold getValinR; Intros.
Inversion_clear H1.
Apply H6.
Unfold T_notjlo.
Inversion_clear H4.
Inversion_clear H1.
Inversion_clear H4.
Inversion_clear H1.
Inversion_clear H4.
Exists x; Exists x0; Exists x1.
Constructor; Auto.
Unfold getValinR.
Inversion_clear H8.
Rewrite <- H7.
Constructor; Auto.
(* ld cursize hp(size) *)
Apply I_ld with [s:(heap*rfile)]
  (EX lnk | (EX n | (EX m | (EX q | (EX siz |
            ((star
		(star (MBlk (plus (2) (getValinR s r5)) lnk (getValinR s r13))
		  (MBlk (plus (2) (getValinR s r4)) q siz))
		(star 
                  (star Pred
                    (MBlkLst m (getValinR s r2) (getValinR s r5)))
		  (MBlkLst n q O))
		   s)
                   /\(getValinR s r0)=f
                   /\((lt (getValinR s r5) (getValinR s r4))
		   /\((lt (getValinR s r4) q) \/ (q=pnil))))
		   /\((getValinR s r4)
                   =(plus (getValinR s r5) (getValinR s r13)))
		   /\(getValinR s cursize)=siz))))).
Unfold updateR; Unfold getValinR.
Intros; Unfold lookupR; Fold lookupR; Unfold beq_reg.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H3.
Inversion_clear H6.
Cut (EX q | (EX siz |
      ((star
	  (star
            (MBlk (plus (2) (lookupR R r5)) x
              (lookupR R r13))
            (MBlk (plus (2) (lookupR R r4)) q siz))
	  (star
            (star Pred
              (MBlkLst x1 (lookupR R r2) (lookupR R r5)))
            (MBlkLst x0 q (0))) (H2,(consR R r8 siz))))
	     /\ ((lt (lookupR R r4) q)\/(q=pnil)))).
Clear H4; Intro H4; Inversion_clear H4.
Inversion_clear H6.
Inversion_clear H4.
Exists x3.
Constructor.
Apply Read_Star_MBlk_siz with (consR R r8 x3) x2
  (star (MBlk (plus (2) (lookupR R r5)) x (lookupR R r13))
    (star (star Pred (MBlkLst x1 (lookupR R r2) (lookupR R r5)))
      (MBlkLst x0 x2 (0)))).
Apply star_assoc_L.
Apply star_subst with
  (star (MBlk (plus (2) (lookupR R r5)) x (lookupR R r13))
    (MBlk (plus (2) (lookupR R r4)) x2 x3))
  (star (star Pred (MBlkLst x1 (lookupR R r2) (lookupR R r5)))
    (MBlkLst x0 x2 (0))); Auto.
Intro; Apply star_sym.
Exists x; Exists x0; Exists x1; Exists x2; Exists x3.
Constructor; Auto.
Cut (star (MBlkLst (S x0) (lookupR R r4) (0))
    (star Pred
      (star (MBlkLst x1 (lookupR R r2) (lookupR R r5))
        (MBlk (plus (2) (lookupR R r5)) x (lookupR R r13)))) (H2,R)).
Clear H4; Intro H4.
Cut (EX q:nat | (EX siz:nat |
      (star
        (star (MBlk (plus (2) (lookupR R r4)) q siz)
          (MBlkLst x0 q (0)))
        (star
	  (MBlk (plus (2) (lookupR R r5)) x (lookupR R r13))
	  (star Pred (MBlkLst x1 (lookupR R r2) (lookupR R r5))))
	(H2,(consR R r8 siz)))
	 /\ ((lt (lookupR R r4) q)\/(q=pnil)))).
Clear H4; Intro H4.
Inversion_clear H4.
Inversion_clear H6.
Inversion_clear H4.
Exists x2; Exists x3.
Constructor; Auto.
Apply star_subst with
  (star (MBlk (plus (2) (lookupR R r4)) x2 x3)
    (MBlk (plus (2) (lookupR R r5)) x (lookupR R r13)))
  (star (MBlkLst x0 x2 (0))
    (star Pred (MBlkLst x1 (lookupR R r2) (lookupR R r5)))).
Apply star_assoc_R.
Apply star_subst with (MBlk (plus (2) (lookupR R r4)) x2 x3)
  (star (MBlkLst x0 x2 (0))
    (star (MBlk (plus (2) (lookupR R r5)) x (lookupR R r13))
      (star Pred (MBlkLst x1 (lookupR R r2) (lookupR R r5))))); Auto.
Apply star_assoc_L; Auto.
Clear H6; Intros.
Apply star_assoc_L.
Apply star_subst with
     (star (MBlkLst x0 x2 (0))
       (MBlk (plus (2) (lookupR R r5)) x (lookupR R r13)))
     (star Pred (MBlkLst x1 (lookupR R r2) (lookupR R r5))); Auto.
Apply star_assoc_R; Auto.
Clear H4; Intro; Apply star_sym.
Intro; Apply star_sym.
Intro; Apply star_sym.
Cut (EX q:nat |
      (EX siz:nat |
         (star
           (star (MBlk (plus (2) (lookupR R r4)) q siz)
             (MBlkLst x0 q (0)))
           (star (MBlk (plus (2) (lookupR R r5)) x (lookupR R r13))
             (star Pred (MBlkLst x1 (lookupR R r2) (lookupR R r5))))
           (H2,R))
	    /\ ((lt (lookupR R r4) q)\/(q=pnil)))).
Clear H4; Intro H4.
Inversion_clear H4.
Inversion_clear H6.
Inversion_clear H4.
Exists x2; Exists x3.
Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply RF_Insensitive_Distrib_Star.
Intro; Apply MBlk_RF_Insensitive.
Intro; Apply MBlkLst_RF_Insensitive.
Intro; Apply RF_Insensitive_Distrib_Star.
Intro; Apply MBlk_RF_Insensitive.
Intro; Apply RF_Insensitive_Distrib_Star.
Intro; Apply H0.
Intro; Apply MBlkLst_RF_Insensitive.
Apply Star_Unfold_MBlkLst.
Apply star_subst with (MBlkLst (S x0) (lookupR R r4) (0))
         (star Pred
           (star (MBlkLst x1 (lookupR R r2) (lookupR R r5))
             (MBlk (plus (2) (lookupR R r5)) x (lookupR R r13)))); Auto.
Intros.
Apply star_sym; Apply star_assoc_R; Auto.
Apply star_sym; Auto.
(* add newsize prevsize cursize *)
Apply I_add with [s:(heap*rfile)]
    (EX lnk | (EX n | (EX m | (EX q | (EX siz |
              ((star
                  (star
                    (MBlk (plus (2) (getValinR s r5)) lnk
                      (getValinR s r13))
                    (MBlk (plus (2) (getValinR s r4)) q siz))
                  (star
                    (star Pred
                      (MBlkLst m (getValinR s r2)
                        (getValinR s r5))) (MBlkLst n q (0))) s)
			 /\(getValinR s r0)=f
                         /\((lt (getValinR s r5) (getValinR s r4))
			 /\ ((lt (getValinR s r4) q)\/(q=pnil))))
			 /\(getValinR s r4)
                         =(plus (getValinR s r5) (getValinR s r13))
			 /\(getValinR s r8)=siz)))))
  /\(getValinR s newsize)=(plus (getValinR s prevsize) (getValinR s cursize)).
Unfold updateR; Unfold getValinR.
Intros; Unfold lookupR; Fold lookupR; Unfold beq_reg.
Constructor; Auto.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H3.
Exists x; Exists x0; Exists x1; Exists x2; Exists x3.
Inversion_clear H4.
Inversion_clear H3.
Constructor; Auto.
Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply RF_Insensitive_Distrib_Star.
Intro; Apply MBlk_RF_Insensitive.
Intro; Apply MBlk_RF_Insensitive.
Intro; Apply RF_Insensitive_Distrib_Star.
Intro; Apply RF_Insensitive_Distrib_Star.
Intro; Apply H0.
Intro; Apply MBlkLst_RF_Insensitive.
Intro; Apply MBlkLst_RF_Insensitive.
(* ld curlink hp(link) *)
Apply I_ld with [s:(heap*rfile)]
    (EX lnk | (EX n | (EX m | (EX q | (EX siz |
              ((star
                  (star
                    (MBlk (plus (2) (getValinR s r5)) lnk
                      (getValinR s r13))
                    (MBlk (plus (2) (getValinR s r4)) q siz))
                  (star
                    (star Pred
                      (MBlkLst m (getValinR s r2)
                        (getValinR s r5))) (MBlkLst n q (0))) s)
			 /\(getValinR s r0)=f
                         /\((lt (getValinR s r5) (getValinR s r4))
			 /\ ((lt (getValinR s r4) q) \/ (q=pnil))))
			 /\(getValinR s r4)
                         =(plus (getValinR s r5) (getValinR s r13))
			 /\(getValinR s r8)=siz
			 /\(getValinR s r11)
			 =(plus (getValinR s r13) (getValinR s r8))
			 /\(getValinR s curlink)=q))))).
Unfold updateR; Unfold getValinR.
Intros; Unfold lookupR; Fold lookupR; Unfold beq_reg.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H6; Inversion_clear H7.
Exists x2.
Constructor.
Apply Read_Star_MBlk_lnk with R x3
    (star (MBlk (plus (2) (lookupR R r5)) x (lookupR R r13))
      (star (star Pred (MBlkLst x1 (lookupR R r2) (lookupR R r5)))
        (MBlkLst x0 x2 (0)))).
Apply star_assoc_L.
Apply star_subst with
         (star (MBlk (plus (2) (lookupR R r5)) x (lookupR R r13))
           (MBlk (plus (2) (lookupR R r4)) x2 x3))
         (star (star Pred (MBlkLst x1 (lookupR R r2) (lookupR R r5)))
           (MBlkLst x0 x2 (0))); Auto.
Intro; Apply star_sym.
Exists x; Exists x0; Exists x1; Exists x2; Exists x3.
Constructor; Auto.
Constructor; Auto.
Apply RF_Insensitive_Distrib_Star with R; Auto.
Intro; Apply RF_Insensitive_Distrib_Star.
Intro; Apply MBlk_RF_Insensitive.
Intro; Apply MBlk_RF_Insensitive.
Intro; Apply RF_Insensitive_Distrib_Star.
Intro; Apply RF_Insensitive_Distrib_Star.
Intro; Apply H0.
Intro; Apply MBlkLst_RF_Insensitive.
Intro; Apply MBlkLst_RF_Insensitive.
(* st prev(size) newsize *)
Apply I_st with [s:(heap*rfile)]
      (EX lnk:nat |
         (EX n:nat |
            (EX m:nat |
               (EX q:nat |
                  (EX siz:nat |
                    ((star
                        (MBlk (plus (2) (getValinR s r5)) lnk
                          (getValinR s newsize))
                        (star
                          (star Pred
                            (MBlkLst m (getValinR s r2)
                              (getValinR s r5))) (MBlkLst n q (0))) s)
                      /\(getValinR s r0)=f
                        /\((lt (getValinR s r5) (getValinR s r4))
			       /\ ((lt (getValinR s r4) q)\/(q=pnil))))
                     /\(getValinR s r4)
                        =(plus (getValinR s r5) (getValinR s r13))
                       /\(getValinR s r8)=siz
      /\(getValinR s r11)=(plus (getValinR s r13) (getValinR s r8))
			       /\(getValinR s r15)=q))))).
Unfold updateR; Unfold getValinR; Intros.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H3.
Inversion_clear H5.
Inversion_clear H7.
Inversion_clear H8.
Constructor.
Apply Star_MBlk_indom with R x (lookupR R r13)
	  (star (MBlk (plus (2) (lookupR R r4)) x2 x3)
	    (star (star Pred (MBlkLst x1 (lookupR R r2) (lookupR R r5)))
              (MBlkLst x0 x2 (0)))).
Apply star_assoc_L; Auto.
Apply lt_trans with (2); Auto.
Apply gt_lt.
Apply Star_MBlk_siz_gt_2 with (H2,R) (plus (2) (lookupR R r5)) x
	  (star (MBlk (plus (2) (lookupR R r4)) x2 x3)
	    (star (star Pred (MBlkLst x1 (lookupR R r2) (lookupR R r5)))
              (MBlkLst x0 x2 (0)))).
Apply star_assoc_L; Auto.
Exists x; Exists x0; Exists x1; Exists x2; Exists x3.
Constructor; Auto.
Constructor; Auto.
Rewrite H7; Apply Write_Star_MBlk_siz.
Apply star_subst with
          (star (MBlk (plus (2) (lookupR R r5)) x (lookupR R r13))
            (MBlk (plus (2) (lookupR R r4)) x2 x3))
          (star (star Pred (MBlkLst x1 (lookupR R r2) (lookupR R r5)))
            (MBlkLst x0 x2 (0))); Auto.
Intros.
Apply star_subst with (MBlk (plus (2) (lookupR R r5)) x (lookupR R r13))
          (MBlk (plus (2) (lookupR R r4)) x2 x3); Auto.
Intro; Rewrite <- H3; Rewrite H5.
Apply MBlk_ptoanylist.
(* st prev(link) curlink *)
Apply I_st with [s:state]
    (star Pred (Good (getValinR s flist)) s)/\(getValinR s ret0)=f.
Unfold getValinR; Intros.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H3.
Inversion_clear H5; Inversion_clear H6.
Inversion_clear H7; Inversion_clear H8.
Inversion_clear H9.
Constructor.
Apply Star_MBlk_indom with R x (lookupR R r11)
    (star (star Pred (MBlkLst x1 (lookupR R r2) (lookupR R r5)))
      (MBlkLst x0 x2 (0))); Auto.
Apply lt_trans with (2); Auto with arith.
Apply gt_lt.
Apply Star_MBlk_siz_gt_2 with (H2,R) (plus (2) (lookupR R r5)) x
    (star (star Pred (MBlkLst x1 (lookupR R r2) (lookupR R r5)))
      (MBlkLst x0 x2 (0))); Auto.
Constructor; Auto.
Cut (EX n | (star Pred (MBlkLst n (lookupR R r2) (0))
	((hwrite H2 (plus (0) (lookupR R r5)) (lookupR R r15)),R))).
Clear H4; Intros.
Inversion_clear H4.
Apply star_subst with Pred (MBlkLst x4 (lookupR R r2) (0)); Auto.
Intros; Exists x4; Auto.
Exists (plus x1 (S x0)).
Apply star_subst with Pred
    (star (star (MBlkLst x1 (lookupR R r2) (lookupR R r5))
       (MBlk (plus (2) (lookupR R r5)) x2 (lookupR R r11)))
     (MBlkLst x0 x2 (0))); Auto.
Apply star_assoc_L.
Apply star_subst with
     (star (MBlk (plus (2) (lookupR R r5)) x2 (lookupR R r11))
       (star (MBlkLst x1 (lookupR R r2) (lookupR R r5)) Pred))
     (MBlkLst x0 x2 (0)); Auto.
Apply star_assoc_R.
Replace (plus O (lookupR R r5)) with (lookupR R r5); Auto with arith.
Rewrite H11; Apply Write_Star_MBlk_lnk with x.
Apply star_subst with (MBlk (plus (2) (lookupR R r5)) x (lookupR R r11))
     (star (star Pred (MBlkLst x1 (lookupR R r2) (lookupR R r5)))
       (MBlkLst x0 x2 (0))); Auto.
Clear H4; Intros.
Apply star_subst with (star Pred (MBlkLst x1 (lookupR R r2) (lookupR R r5)))
         (MBlkLst x0 x2 (0)); Auto.
Intro; Apply star_sym.
Intros; Apply star_assoc_L.
Apply star_sym.
Apply star_subst with (MBlk (plus (2) (lookupR R r5)) x2 (lookupR R r11))
         (star (MBlkLst x1 (lookupR R r2) (lookupR R r5)) Pred); Auto.
Intro; Apply star_sym.
Clear H4; Intros.
Apply Compose_Blk with (lookupR R r5) x2 (lookupR R r11); Auto.
Inversion_clear H10; Auto.
Left; Apply lt_trans with (lookupR R r4); Auto.
(* jmp ret0 *)
Apply I_jmp.
Intros.
Inversion_clear H3.
Unfold getValinR in H5; Rewrite H5; Apply H; Auto.
Save.

Theorem WF_notjlo : (Pred:assert; ct:codeheapty; f:lab)
 ((s:state)(Q_free Pred s) ->
   (exT assert ([A:assert](lookupCT ct f A) /\ (A s))))
  -> ((H:heap;R,R':rfile)(Pred (H,R)) -> (Pred (H,R')))
  -> (Infer ct (T_notjlo Pred f) C_notjlo).
Proof.
Intros; Unfold T_notjlo; Unfold C_notjlo.
(* st prev(link) hp *)
Apply I_st with [s:state](star Pred (Good (getValinR s flist)) s)
  /\ (getValinR s ret0)=f.
Unfold getValinR; Intros.
Inversion_clear H2.
Inversion_clear H3.
Inversion_clear H2.
Inversion_clear H3.
Inversion_clear H4.
Inversion_clear H2.
Cut (star (MBlk (plus (2) (lookupR R r5)) x (lookupR R r13))
   (star
     (star Pred (MBlkLst x1 (lookupR R r2) (lookupR R r5)))
     (MBlkLst (S x0) (lookupR R r4) (0))) (H1,R)).
Clear H4; Intros.
Constructor.
Apply Star_MBlk_indom with R x (lookupR R r13)
 (star (star Pred (MBlkLst x1 (lookupR R r2) (lookupR R r5)))
   (MBlkLst (S x0) (lookupR R r4) (0))); Auto.
Apply lt_trans with (2); Auto with arith.
Apply Star_MBlk_siz_gt_2 with (H1,R) (plus (2) (lookupR R r5)) x
 (star (star Pred (MBlkLst x1 (lookupR R r2) (lookupR R r5)))
   (MBlkLst (S x0) (lookupR R r4) (0))); Auto.
Constructor; Auto.
Cut (EX n | (star Pred (MBlkLst n (lookupR R r2) pnil)
     ((hwrite H1 (plus (0) (lookupR R r5)) (lookupR R r4)),R))).
Clear H2; Intros.
Inversion_clear H2.
Apply star_subst with Pred (MBlkLst x2 (lookupR R r2) (0)); Auto.
Intros; Exists x2; Auto.
Exists (plus x1 (S (S x0))).
Apply star_subst with Pred
 (star (star (MBlkLst x1 (lookupR R r2) (lookupR R r5))
     (MBlk (plus (2) (lookupR R r5)) (lookupR R r4) (lookupR R r13)))
   (MBlkLst (S x0) (lookupR R r4) (0))); Auto.
Apply star_assoc_L.
Apply star_subst with
     (star (MBlk (plus (2) (lookupR R r5)) (lookupR R r4) (lookupR R r13))
       (star Pred (MBlkLst x1 (lookupR R r2) (lookupR R r5))))
     (MBlkLst (S x0) (lookupR R r4) (0)); Auto.
Apply star_assoc_R.
Apply Write_Star_MBlk_lnk with x; Auto.
Clear H2; Intros.
Apply star_assoc_L.
Apply star_sym; Auto.
Clear H2; Intros.
Apply Compose_Blk with (lookupR R r5) (lookupR R r4) (lookupR R r13); Auto.
Apply star_assoc_L.
Apply star_subst with (star Pred
       (star (MBlkLst x1 (lookupR R r2) (lookupR R r5))
         (MBlk (plus (2) (lookupR R r5)) x (lookupR R r13))))
     (MBlkLst (S x0) (lookupR R r4) (0)); Auto.
Clear H4; Intros.
Apply star_sym; Apply star_assoc_R; Auto.
(* jmp ret0 *)
Apply I_jmp.
Unfold getValinR; Intros.
Inversion_clear H2.
Rewrite H4; Apply H; Auto.
Save.
